"""
    AbstractECC

Abstract type for error correction code.
"""
abstract type AbstractECC end

"""
    AbstractQECC <: AbstractECC

Abstract type for quantum error correction code.
"""
abstract type AbstractQECC <: AbstractECC end

"""
    AbstractCECC <: AbstractECC

Abstract type for classical error correction code.
"""
abstract type AbstractCECC <: AbstractECC end

"""
    parity_matrix(c::AbstractECC)

The parity check matrix of a error correction code in the form of `(X|Z)`. The size of the matrix is `(code_s, 2*code_n)`. `code_s` is the number of stabilizers, and `code_n` is the number of physical qubits. Each row of the matrix is a stabilizer. The first `code_n` columns represent whether this stabilizer contains a X operator on the physical qubit, and the last `code_n` columns represent whether this stabilizer contains a Z operator on the physical qubit.

See also: [`parity_matrix_x`](@ref) and [`parity_matrix_z`](@ref)
"""
function parity_matrix end

"""
    AbstractCSSCode <: AbstractQECC

Abstract type for Calderbank-Shor-Steane (CSS) code.
"""
abstract type AbstractCSSCode <: AbstractQECC end

"""
    parity_matrix_x(c::AbstractCSSCode)

Parity check boolean matrix of a code (only the X entries in the tableau, i.e. the checks for Z errors).
Only CSS codes have this method.

See also: [`parity_matrix`](@ref) and [`parity_matrix_z`](@ref)
"""
function parity_matrix_x end

"""
    parity_matrix_z(c::AbstractCSSCode)

Parity check boolean matrix of a code (only the Z entries in the tableau, i.e. the checks for X errors).
Only CSS codes have this method.

See also: [`parity_matrix`](@ref) and [`parity_matrix_x`](@ref)
"""
function parity_matrix_z end


"""
    code_n(c::AbstractECC)

The number of physical qubits in a error correction code.

See also: [`code_k`](@ref) and [`code_s`](@ref)
"""
code_n(c::AbstractQECC) = nqubits(parity_matrix(c))
code_n(c::AbstractCECC) = nbits(parity_matrix(c))
nqubits(pm::AbstractMatrix{Bool}) = size(pm, 2) ÷ 2
nbits(pm::AbstractMatrix{Bool}) = size(pm, 2)

"""
    code_s(c::AbstractECC)

The number of stabilizers in a error correction code. They might not be all linearly independent, thus `code_s >= code_n-code_k`. For the number of linearly independent checks you can use `LinearAlgebra.rank`.

See also: [`code_n`](@ref) and [`code_k`](@ref)
"""
function code_s end
code_s(c::AbstractQECC) = size(parity_matrix(c), 1)

"""
    code_k(c::AbstractECC)

The number of logical qubits in a error correction code.

See also: [`code_n`](@ref) and [`code_s`](@ref)
"""
function code_k end

"""
    rate(c::AbstractECC)

The rate of a error correction code.

See also: [`code_n`](@ref) and [`code_k`](@ref)
"""
function rate(c)
    rate = code_k(c)//code_n(c)
    return rate
end

"""
    distance(c::AbstractECC)

The code distance of a error correction code.

See also: [`code_n`](@ref) and [`code_k`](@ref)
"""
function distance end

"""
    AbstractDistanceAlg

Abstract type representing algorithms for computing
the minimum distance of quantum error correction codes.
"""
abstract type AbstractDistanceAlg end

"""
    metacheck_matrix_x(c::AbstractCSSCode)

Returns the X-metacheck matrix (``M_X = \\partial_{i-1}``) for a CSS code defined
by a [chain complex](https://en.wikipedia.org/wiki/Chain_complex) of length `l ≥ 4`,
where qubits are placed on `i`-cells with ``1 < i < l−1``.

This matrix acts on X-syndromes (measurement outcomes from X-type stabilizers that
detect Z-errors, obtained via [`parity_matrix_x`](@ref) and enforces the constraint
``M_X s_X = 0``, ensuring syndromes ``s_X`` are valid codewords of a classical *metacode*.

!!! note
    For an introduction to [chain complexes](https://en.wikipedia.org/wiki/Chain_complex) in
    quantum error correction and the role of metachecks in single-shot QEC, see the documentation
    for [`metacheck_matrix`](@ref).

### Example: 4D surface code

In the 5-term chain complex used for the 4D surface code:

```math
\\begin{aligned}
C_4 \\xrightarrow{\\partial_4} C_3 \\xrightarrow{\\partial_3} C_2 \\xrightarrow{\\partial_2} C_1 \\xrightarrow{\\partial_1} C_0
\\end{aligned}
```

the metacheck matrix ``M_X = \\partial_1`` obtained via [`metacheck_matrix_x`](@ref) satisfies the following:

- Acts on X-syndromes: ``s_X \\in C_1``.
- It enforces ``M_Xs_X = 0``, i.e. only valid syndromes lie in ``\\ker M_X``.
- It satisfies the boundary condition ``M_XH_X = 0`` (i.e., ``\\partial_1 \\partial_2 = 0``)  where ``H_Z`` and ``M_Z`` are obtained via [`parity_matrix_x`](@ref) and [`metacheck_matrix_x`](@ref) respectively.

See also: [`metacheck_matrix_z`](@ref), [`metacheck_matrix`](@ref), [`parity_matrix_x`](@ref)
"""
function metacheck_matrix_x end

"""
    metacheck_matrix_z(c::AbstractCSSCode)

Returns the Z-metacheck matrix (``M_Z = \\partial_{i+2}^\\top``) for a CSS code
defined by a chain complex of length `l ≥ 4`, where qubits are placed on `i`-cells
(`1 < i < l−1`).

This matrix acts on Z-syndromes (measurement outcomes from Z-type stabilizers that
detect X-errors, obtained via [`parity_matrix_z`](@ref) and enforces the constraint
``M_Z s_Z = 0``, ensuring syndromes ``s_Z`` are valid codewords of a classical *metacode*.

!!! note
    For an introduction to chain complexes in quantum error correction and the role
    of metachecks in single-shot QEC, see the documentation for [`metacheck_matrix`](@ref).

### Example: 4D Surface Code

In the `5`-term chain complex used for the `4D` surface code:

```math
\\begin{aligned}
C_4 \\xrightarrow{\\partial_4} C_3 \\xrightarrow{\\partial_3} C_2 \\xrightarrow{\\partial_2} C_1 \\xrightarrow{\\partial_1} C_0
\\end{aligned}
```

the metacheck matrix ``M_Z = \\partial_4`` obtained via [`metacheck_matrix_z`](@ref) satisfies the following:

- Acts on Z-syndromes: ``s_Z \\in C_3``,
- It enforces ``M_Zs_Z = 0``, i.e. only valid syndromes lie in ``\\ker M_Z``.
- It satisfies the boundary condition ``H_Z^\\topM_Z^\\top = 0`` (i.e., ``\\partial_3 \\partial_4 = 0``) where ``H_Z`` and ``M_Z`` are obtained via [`parity_matrix_z`](@ref) and [`metacheck_matrix_z`](@ref) respectively.

See also: [`metacheck_matrix_x`](@ref), [`metacheck_matrix`](@ref), [`parity_matrix_z`](@ref)
"""
function metacheck_matrix_z end

"""
    metacheck_matrix(c::AbstractCSSCode)

Return the X- and Z-metacheck matrices for CSS codes enabling **single-shot
quantum error correction** — a fault-tolerant scheme that corrects both data and
measurement errors using **one** round of syndrome measurements ([Higgott_2023](@cite),
[quintavalle2021single](@cite)).

### Single-Shot QEC

Single-shot QEC enables both physical errors on qubits and errors in syndrome measurements
to be detected and corrected using only a *single round of noisy measurements*, without
requiring repeated measurement rounds. A layer of redundancy is added to the measurement
process itself. This redundancy is captured by *metasyndromes*: linear constraints that the
noisy syndrome outcomes must satisfy if no measurement error has occurred. When violated, they
indicate faults in the syndrome extraction layer itself.

Traditional QEC combats measurement faults by repeating stabilizer measurements. In contrast,
**single-shot QEC** uses *spatial redundancy* via **metachecks** — extra linear constraints
on syndrome outcomes ("checks of checks") to detect and correct measurement errors immediately.

As noted in [Higgott_2023](@cite): "Some single-shot codes have *linear dependencies*
amongst the check operators, leading to syndromes becoming code words of a classical
linear code (called a *metacode*) that can be used for syndrome repair. These linear
dependencies are not a requirement for a code to be single-shot (indeed, quantum expander
codes are single shot and confined but can have full-rank check matrices); however, a
metacode can nevertheless be useful when decoding. We can construct a code that has
syndromes encoded in a metacode using a chain complex with length at least 3 (to obtain
a metacode for either X or Z syndromes), or length 4 if we would like a metacode for both
X and Z syndromes."

### Confinement and Single-Shot Decoding

Metachecks enable single-shot decoding by providing a metacode for syndrome repair,
but their role is best understood through the broader property of **confinement** [Higgott_2023](@cite):

- A code has *(t,f)*-confinement if, for all errors *E* with ``|E|_{\\text{red}} \\leq t``,
the syndrome weight satisfies ``f(|\\sigma(E)|) \\geq |E|_{\\text{red}}``, where
``f: \\mathbb{Z} \\to \\mathbb{R}`` is an increasing function. This bounds the physical
error weight by a function of the syndrome weight.

Codes with metachecks (e.g., D-dimensional surface and toric codes) exhibit confinement
because ``M_X/M_Z`` constrain syndromes to a metacode, but confinement can exist *without*
metachecks (e.g., quantum expander codes). Thus, while metachecks are sufficient for single-shot
QEC (via syndrome repair), they are not strictly necessary.

### Repair-Syndrome Decoding

To correct errors in CSS codes, a **two-stage** decoder can be employed when given a noisy
syndrome measurement `z′`. This method separately addresses data qubit errors (e.g., `Z`-errors)
and syndrome measurement errors (e.g., faulty X-stabilizer measurements). The same approach
applies symmetrically for X-errors and Z-stabilizer measurements.

#### Stage I: Syndrome Repair via Metachecks

- The metacheck matrix ``M_X`` computes the metasyndrome ``s = M_Xz'``, identifying inconsistencies caused by measurement errors.
- A classical decoder ``f^1_d : \\mathbb{F}^{n_{i-2}}_2 \\rightarrow \\mathbb{F}^{n_{i-1}}_2`` estimates the noiseless syndrome ``z`` from ``s``, effectively "repairing" the syndrome.

#### Stage II: Data Qubit Correction

A second decoder ``f^2_d : \\mathbb{F}^{n_{i-1}}_2 \\rightarrow \\mathbb{F}^n_2``​ uses the
corrected syndrome `z` to compute a noise vector `n` such that ``H_{X}n = z``, determining
the most likely data qubit errors.

The correction can fail in two ways:
- **Invalid Syndrome**: The repaired `z` lies outside the valid syndrome space ``im(H_X​``).
- **Logical Error**: The correction `n` corresponds to a nontrivial logical operator (i.e., ``n \\in \\ker(H_X)``).

To mitigate the first failure (i.e. invalid syndrome), we can modify the metacheck matrix to

```math
\\begin{aligned}
M' = \\begin{pmatrix}
M_X \\\\
L_M
\\end{pmatrix}
\\end{aligned}
```

where ``L_M`` spans the cohomology group ``H^{i-1}``. However, if ``L_M`` is non-sparse
(common in topological codes), decoding efficiency may suffer.

!!! note
    The modified metacheck matrix ``M'`` is only employed when the initial decoding
    attempt yields an invalid syndrome (``z \\notin \\text{im}(H_X)``). This approach
    helps maintain decoder efficiency, particularly for topological codes where ``L_M`` is
    typically non-sparse [Higgott_2023](@cite). However, the overall performance of two-stage
    decoders remains fundamentally constrained by the metacode's threshold, often resulting
    in suboptimal error correction capability.

### Single-Stage Decoding

Single-stage decoding provides a unified framework for correcting both data qubit errors
(`e`) and syndrome measurement errors (`s_e`) simultaneously [Higgott_2023](@cite). Given an
observed syndrome ``s = H_X e + s_e``, where `H_X` is the `X`-stabilizer matrix, the decoder
seeks the most probable error configuration ``e' = \\begin{pmatrix}e \\\\ s_e\\end{pmatrix}``
that satisfies the extended parity-check equation:

```math
\\begin{aligned}
H' e' = s \\quad \\text{where} \\quad H' = \\begin{pmatrix}H_X & I_r\\end{pmatrix}
\\end{aligned}
```

The Tanner graph ``T(H')`` for this system is constructed by augmenting the original Tanner
graph ``T(H_X)`` with additional variable nodes ``\\{v_i^m\\}_{i=1}^r`` representing potential
measurement errors. Each check node ``f_i`` gains a corresponding edge ``(v_i^m, f_i)``, creating
a structure where measurement errors appear explicitly in the decoding graph.

The decoding framework can be further enhanced by explicitly incorporating *metachecks* through
the extended matrix:

```math
\\begin{aligned}
\\begin{equation}
H_M = \\begin{pmatrix}
H_X & I_r \\\\
0 & M
\\end{pmatrix}
\\end{equation}
\\end{aligned}
```

where ``M`` is the metacheck matrix. Though these metachecks are implicitly present as linear
combinations in ``T(H')``, their explicit inclusion significantly improves decoder performance.

The single-stage decoding approach offers several key advantages over two-stage methods, including the
elimination of metacode failures—since the combined error syndrome ``s + s_e`` is within the image of ``H_X``
by construction—along with the avoidance of non-sparse ``L_M`` matrices that can degrade decoder performance,
and ultimately yielding improved thresholds for topological codes [Higgott_2023](@cite).

### Chain Complexes and ``\\mathbb{F_2}`` Homology

A chain complex of length `l` is a [sequence](https://en.wikipedia.org/wiki/Exact_sequence) of [vector
spaces](https://en.wikipedia.org/wiki/Vector_space) connected by [boundary](https://en.wikipedia.org/wiki/Boundary_(topology))
maps:

```math
\\begin{aligned}
\\{0\\} \\xrightarrow{\\partial_{l+1}} C_l \\xrightarrow{\\partial_l} C_{l-1} \\xrightarrow{\\partial_{l-1}} \\cdots \\xrightarrow{\\partial_1} C_0 \\xrightarrow{\\partial_0} \\{0\\}
\\end{aligned}
```

where

- Each ``C_i`` is called an *i-cell*.
- The [image](https://en.wikipedia.org/wiki/Image_(mathematics)) of ``\\partial_{i+1}``, denoted ``\\mathrm{im}\\partial_{i+1}``, consists of *i-boundaries*.
- The [kernel](https://en.wikipedia.org/wiki/Kernel_(algebra)#Linear_maps) of ``\\partial_i``, denoted ``\\ker\\partial_i``, consists of *i-cycles*.

The boundary maps satisfy the constraint:

```math
\\begin{aligned}
\\partial_i \\circ \\partial_{i+1} = 0 \\quad \\text{for all } i \\in \\{0, \\dots, l\\}
\\end{aligned}
```

Because ``\\partial_i \\circ \\partial_{i+1} = 0``, every boundary is a cycle:

```math
\\begin{aligned}
\\mathrm{im}\\partial_{i+1} \\subseteq \\ker\\partial_i
\\end{aligned}
```

The **i-th [homology](https://en.wikipedia.org/wiki/Homology_(mathematics)) group** measures
the difference between cycles and boundaries:

```math
\\begin{aligned}
H_i = \\frac{\\ker\\partial_i}{\\mathrm{im}\\partial_{i+1}}
\\end{aligned}
```

Associated with a chain complex is a **cochain complex** with *coboundary operators*
``\\delta^i: C^i \\to C^{i+1}``, typically defined as the transpose (or dual) of the boundary maps:

```math
\\begin{aligned}
\\{0\\} \\xrightarrow{\\delta^{-1}} C^0 \\xrightarrow{\\delta^0} C^1 \\xrightarrow{\\delta^1} \\cdots \\xrightarrow{\\delta^{l-1}} C^l \\xrightarrow{\\delta^l} \\{0\\}
\\end{aligned}
```

where

- ``\\ker\\delta^i`` consists of *i-cocycles*.
- ``\\mathrm{im}\\delta^{i-1}`` consists of *i-coboundaries*.

The **i-th cohomology group** is:

```math
\\begin{aligned}
H^i = \\frac{\\ker\\delta^i}{\\mathrm{im}\\delta^{i-1}}
\\end{aligned}
```

### CSS codes using Homological Algebra

Quantum CSS codes can be described using the framework of [chain complexes](https://en.wikipedia.org/wiki/Chain_complex).

For a chain complex of length `l ≥ 4` , where qubits are placed on `i`-cells (`C_i`) with (`1 < i < l−1`):

```math
\\begin{aligned}
C_{l-1} \\xrightarrow{\\partial_{l-1}} \\cdots \\xrightarrow{\\partial_{i+2}} C_{i+1} \\xrightarrow{\\partial_{i+1}} C_i \\xrightarrow{\\partial_i} C_{i-1} \\xrightarrow{\\partial_{i-1}} \\cdots \\xrightarrow{\\partial_1} C_0
\\end{aligned}
```

where

- `parity_checks_x(c)`: **X-stabilizers** are given by the boundary map ``H_X = \\partial_i: C_i → C_{i-1}``.
- `parity_checks_z(c)`: **Z-stabilizers** are given by the coboundary map ``H_Z = \\partial_{i+1}^T: C_i → C_{i+1}``.
- `metacheck_matrix_x(c)`: **X-metachecks** are defined as ``M_X = \\partial_{i-1}: C_{i-1} → C_{i-2}``.
- `metacheck_matrix_z(c)`: **Z-metachecks** are defined as ``M_Z = \\partial_{i+2}^T: C_{i+2} → C_{i+1}``.

The boundary conditions ``\\partial_{i-1} \\partial_i = 0`` (i.e., ``M_X H_X = 0``) guarantee that valid syndromes
(`im H_X`) lie in `ker M_X`.

Invalid syndromes in ``ker M_X \\setminus im H_X`` belong to the ``(i−1)``-th homology group
``H_{i-1} = \\ker \\partial_{i-1} / \\mathrm{im} \\partial_i``, while invalid `Z`-syndromes in
``ker M_Z \\setminus im H_Z`` belong to the ``(i+1)``-th cohomology group.

!!! note
    A code can be designed to incorporate syndromes within a metacode by employing a chain complex
    of minimum length three—sufficient for encoding either X or Z syndromes. If the goal is to
    include both X and Z syndromes in the metacode, the chain complex must extend to at least
    length four [Higgott_2023](@cite).

### Metachecks in Higher-Dimensional Complexes

In D-dimensional codes, such as the `4D` surface code, we consider a `5`-term chain complex:

```math
\\begin{aligned}
C_4 \\xrightarrow{\\partial_4} C_3 \\xrightarrow{\\partial_3} C_2 \\xrightarrow{\\partial_2} C_1 \\xrightarrow{\\partial_1} C_0
\\end{aligned}
```

In this chain complex framework:

- Standard parity checks are: ``\\partial_3 = H_Z^\\top``, and ``\\partial_2 = H_X``
- Metachecks correspond to: ``\\partial_4 = M_Z^\\top``, and ``\\partial_1 = M_X``

#### Syndrome Validation

The matrices `M_X` and `M_Z` enforce syndrome validity via boundary conditions from the chain complex:

```math
\\begin{aligned}
M_Xs_X = 0 \\quad &\\text{for X-syndromes } (s_X \\in C_1) \\\\
M_Zs_Z = 0 \\quad &\\text{for Z-syndromes } (s_Z \\in C_3)
\\end{aligned}
```

See also: [`metacheck_matrix_x`](@ref), [`metacheck_matrix_z`](@ref)
"""
function metacheck_matrix end

"""Implemented in a package extension with `Oscar`."""
function bivariate_bicycle_code_k end

"""
    generator_polynomial(c::AbstractCECC)

The generator polynomial g(x) of a [cyclic code](https://en.wikipedia.org/wiki/Cyclic_code)
which generates the ideal corresponding to the code in the quotient ring ``\\mathbb{F}_q[x]/(x^n - 1)``.

The generator polynomial is the unique *monic* polynomial of minimal degree in the
[polynomial code](https://en.wikipedia.org/wiki/Polynomial_code). For a cyclic
code C of length n over ``\\mathbb{F}_q``, g(x) satisfies:
- g(x) divides ``x^n - 1`` in ``\\mathbb{F}_q[x]``.
- The degree of g(x) is n - k, where k is the code dimension for the non-degenerate case.
- Every codeword polynomial ``c(x) \\in C`` can be expressed as ``c(x) = m(x)g(x) \\mod (x^n - 1)``.

The input is a classical polynomial error-correcting code defined over a finite field.
"""
function generator_polynomial end

hasmetachecks(c::AbstractQECC) = (false, false)

@testitem "Doctests" tags=[:doctests] begin
    using Documenter
    using QECCore
    using QuantumClifford

    extensions = []

    import Nemo
    const QECCoreNemoExt = Base.get_extension(QECCore, :QECCoreNemoExt)
    push!(extensions, QECCoreNemoExt)

    @static if !Sys.iswindows() && Sys.ARCH == :x86_64 && VERSION >= v"1.11"
        import Oscar
        const QECCoreOscarExt = Base.get_extension(QECCore, :QECCoreOscarExt)
        push!(extensions, QECCoreOscarExt)
    end

    ENV["LINES"] = 80    # for forcing `displaysize(io)` to be big enough
    ENV["COLUMNS"] = 80
    DocMeta.setdocmeta!(QECCore, :DocTestSetup, :(using QECCore; using QuantumClifford); recursive=true)
    modules = [QECCore, extensions...]
    doctestfilters = [r"(QECCore\.|)"]
    doctest(nothing, modules;
            doctestfilters
            #fix=true
           )
    # TODO failures in VSCode related to https://github.com/julia-vscode/TestItemRunner.jl/issues/49
end

@testitem "Quantum Tanner Graph Codes" begin

    using Random
    using Graphs
    using Graphs: is_bipartite
    using SparseArrays
    using QuantumClifford
    using QuantumClifford: stab_looks_good
    using QuantumClifford.ECC
    using QuantumClifford.ECC: parity_matrix_x, parity_matrix_z
    using QECCore
    using QECCore: tanner_graph_from_parity_matrix, parity_matrix_from_tanner_graph, BipartiteGraph

    function verify_orthogonality(HX::AbstractMatrix, HZ::AbstractMatrix)
        product_mod2 = mod.(Int.(HX) * transpose(Int.(HZ)), 2)
        return all(product_mod2 .== 0)
    end

    function generate_random_bipartite_graph(n_vars::Int, n_checks::Int, edge_prob::Float64)
        g = SimpleGraph(n_vars + n_checks)
        var_nodes = collect(1:n_vars)
        check_nodes = collect(n_vars+1:n_vars+n_checks)
        for v in var_nodes, c in check_nodes
            rand() < edge_prob && add_edge!(g, v, c)
        end
        return BipartiteGraph(g, var_nodes, check_nodes)
    end

    function generate_parity_checks(code_type::Symbol, args...)
        if code_type == :RepCode
            n = args[1]
            return parity_matrix(RepCode(n))
        elseif code_type == :ReedMuller
            r, m = args
            return ReedMuller(r, m)
        elseif code_type == :Golay
            n = args[1]
            if n == 23
                return parity_matrix(Golay(n))
            elseif n == 24
                return parity_matrix(Golay(n))
            else
                error("Golay code only supports n = 23 or 24")
            end
        else
            error("Unsupported code type")
        end
    end

    @testset "4.1: Validity of the Construction of Q(G1 × G2)" begin
        @testset "Repetition codes" begin
            for n in 3:10
                H = parity_matrix(RepCode(n))
                c = QuantumTannerGraphProduct(H, H)
                @test stab_looks_good(parity_checks(c); remove_redundant_rows=true)
                hx, hz = parity_matrix_x(c), parity_matrix_z(c)
                @test verify_orthogonality(hx, hz)
            end
        end

        @testset "Cyclic codes" begin
            for n in 3:10
                c = CyclicQuantumTannerGraphProduct(n)
                @test stab_looks_good(parity_checks(c); remove_redundant_rows=true)
                hx, hz = parity_matrix_x(c), parity_matrix_z(c)
                @test verify_orthogonality(hx, hz)
            end
        end

        @testset "Golay codes" begin
            for n in [23, 24]
                H = parity_matrix(Golay(n))
                c = QuantumTannerGraphProduct(H, H)
                @test stab_looks_good(parity_checks(c); remove_redundant_rows=true)
                hx, hz = parity_matrix_x(c), parity_matrix_z(c)
                @test verify_orthogonality(hx, hz)
            end
        end

        @testset "Reed-Muller codes" begin
            for m in 3:5, r in 1:m-1
                H = parity_matrix(ReedMuller(r, m))
                c = QuantumTannerGraphProduct(H, H)
                @test stab_looks_good(parity_checks(c); remove_redundant_rows=true)
                hx, hz = parity_matrix_x(c), parity_matrix_z(c)
                @test verify_orthogonality(hx, hz)
            end
        end
    end

    @testset "Fully connected bipartite graph" begin
        bg = generate_random_bipartite_graph(3, 2, 1.0)
        H = parity_matrix_from_tanner_graph(bg)
        @test Graphs.is_bipartite(bg.g)
        @test all(H .== true)
    end

    @testset "Random bipartite graphs" begin
        for _ in 1:1000
            n_v = rand(1:10)
            n_c = rand(1:10)
            p = rand() * 0.5
            bg = generate_random_bipartite_graph(n_v, n_c, p)
            @test is_bipartite(bg.g)
            H = parity_matrix_from_tanner_graph(bg)
            @test size(H) == (n_c, n_v)
        end
    end

    @testset "Large bipartite graph" begin
        bg = generate_random_bipartite_graph(1000, 50, 0.1)
        H = parity_matrix_from_tanner_graph(bg)
        @test is_bipartite(bg.g)
        @test size(H) == (50, 1000)
        @test nnz(H) > 0
    end
end

@testitem "[[8p, 4p − 2, 3]] Delfosse-Reichardt Generalized [[8,2,3]] codes" begin

    using JuMP
    using HiGHS
    using QuantumClifford
    using QuantumClifford: stab_looks_good, Stabilizer
    using QuantumClifford.ECC
    using Nemo: matrix, GF
    using QECCore.LinearAlgebra
    using QECCore

    # The `[[8, 2, 3]]` non-CSS code serves as the seed code for constructing Delfosse-Reichardt generalized `[[8p, 4p − 2, 3]]`codes.
    _seed₈₂₃ = Bool[0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0;
                    1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0;
                    0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1;
                    0  0  0  0  1  1  1  1  0  0  0  0  0  0  0  0;
                    0  1  1  0  0  1  1  0  0  0  1  1  0  0  1  1;
                    0  0  1  1  0  0  1  1  0  1  0  1  0  1  0  1]

    function _consistency_check(p)
        H = Stabilizer(_seed₈₂₃)
        rows, cols = size(H)
        tab = zero(Stabilizer, rows - 2, cols)
        H_rep₁ = H[1:4, :]
        H_rep₂ = H[5:6, :]
        rows = [hcat(fill(tab, i - 1)..., H_rep₁, fill(tab, p - i)...) for i in 1:p]
        D = vcat(rows...)
        E = hcat(fill(H_rep₂, p)...)
        extended_H = vcat(D, E)
        return extended_H
    end

    @testset "Testing [[8p, 4p − 2, 3]] Delfosse-Reichardt Generalized [[8,2,3]] code properties" begin
        for p in 1:10
            c = DelfosseReichardt823(p)
            n, k = code_n(c), code_k(c)
            stab = parity_checks(c)
            nₛ, kₛ = code_n(stab), code_k(stab)
            H = stab_to_gf2(stab)
            mat = matrix(GF(2), H)
            computed_rank = rank(mat)
            @test stab == _consistency_check(p)
            @test computed_rank == n - k && computed_rank == nₛ - kₛ && n == nₛ && k == kₛ
            @test stab_looks_good(stab, remove_redundant_rows=true)
        end
    end
end

"""
    $TYPEDEF

The Toric code [kitaev2003fault](@cite).
Illustration of a 2x2 toric code, where qubits are located on the edges:
```
|--1-(Z)-2--|
| (X) 5     6
|--3--|--4--|
|     7     8
|     |     |
```

It is important to note that the toric code has periodic boundary conditions, which means that the top and bottom sides are essentially glued together, as are the left and right sides.

Faces like `(1,3,5,6)` have `X` checks, and crosses like `(1,2,5,7)` have `Z` checks.

The parity checks of `Toric(2,2)` are:
```
X_X_XX__
_X_XXX__
X_X___XX
ZZ__Z_Z_
ZZ___Z_Z
__ZZZ_Z_
```

### Fields
    $TYPEDFIELDS
"""
struct Toric <: AbstractCSSCode
    """The number of qubits in the `x` direction."""
    dx::Int
    """The number of qubits in the `z` direction."""
    dz::Int
end

code_n(c::Toric) = 2*c.dx*c.dz

function parity_matrix_xz(c::Toric)
    hx, hz = hgp(parity_matrix(RepCode(c.dz)), parity_matrix(RepCode(c.dx)))
    hx[1:end-1,:], hz[1:end-1,:]
end

parity_matrix_x(c::Toric) = parity_matrix_xz(c)[1]
parity_matrix_z(c::Toric) = parity_matrix_xz(c)[2]

distance(c::Toric) = min(c.dx, c.dz)

"""
    $TYPEDEF

Repetition code is a classical error correction code that repeats the same bit `n` times.

### Fields
    $TYPEDFIELDS
"""
struct RepCode <: AbstractCECC
    """The number of times to repeat the bit."""
    n::Int
end

function parity_matrix(c::RepCode)
    n = c.n
    I = [i for i in 1:n for δ in (0,1)]
    J = [(i+δ-1)%n+1 for i in 1:n for δ in (0,1)]
    V = true
    sparse(I,J,V,n,n)
end

code_n(c::RepCode) = c.n
code_s(c::RepCode) = c.n

@testitem "CirculantBivariateBicycle" begin
    @static if !Sys.iswindows() && Sys.ARCH == :x86_64 && VERSION >= v"1.11"
        using QECCore
        using QECCore.LinearAlgebra
        using QuantumClifford
        using QuantumClifford: stab_looks_good
        using QuantumClifford: stab_to_gf2
        using QuantumClifford.ECC
        using Oscar

        @testset "Generalized CirculantBivariateBicycle codes from [bravyi2024high](@cite)" begin
            test_cases = [
            (
                name = "BB [[108, 8, 10]]",
                l = 9,
                m = 6,
                A = [(:x, 3), (:y, 1), (:y, 2)], # A = x³ + y + y²
                B = [(:y, 3), (:x, 1), (:x, 2)], # B = y³ + x + x²
                expected_n = 108,
                expected_k = 8
            ),
            (
                name = "BB [[90, 8, 10]]",
                l = 15,
                m = 3,
                A = [(:x, 9), (:y, 1), (:y, 2)], # A = x⁹ + y + y²
                B = [(:y, 0), (:x, 2), (:x, 7)], # B = 1 + x² + x⁷
                expected_n = 90,
                expected_k = 8
            ),
            (
                name = "BB [[288, 12, 18]]",
                l = 12,
                m = 12,
                A = [(:x, 3), (:y, 2), (:y, 7)], # A = x³ + y² + y⁷
                B = [(:y, 3), (:x, 1), (:x, 2)], # B = y³ + x + x²
                expected_n = 288,
                expected_k = 12
            ),
            (
                name = "BB [[144, 12, 12]]",
                l = 12,
                m = 6,
                A = [(:x, 3), (:y, 1), (:y, 2)], # A = x³ + y + y²
                B = [(:y, 3), (:x, 1), (:x, 2)], # B = y³ + x + x²
                expected_n = 144,
                expected_k = 12
            ),
            (
                name = "BB [[72, 12, 6]]",
                l = 6,
                m = 6,
                A = [(:x, 3), (:y, 1), (:y, 2)], # A = x³ + y + y²
                B = [(:y, 3), (:x, 1), (:x, 2)], # B = y³ + x + x²
                expected_n = 72,
                expected_k = 12
            ),
            (
                name = "BB [[360, 12, ≤24]]",
                l = 30,
                m = 6,
                A = [(:x, 9), (:y, 1), (:y, 2)],  # A = x⁹ + y + y²
                B = [(:y, 3), (:x, 25), (:x, 26)],# B = y³ + x²⁵ + x²⁶
                expected_n = 360,
                expected_k = 12
            ),
            (
                name = "BB [[756, 16, ≤34]]",
                l = 21,
                m = 18,
                A = [(:x, 3), (:y, 10), (:y, 17)], # A = x³ + y¹⁰ + y¹⁷
                B = [(:y, 5), (:x, 3), (:x, 19)],  # B = y⁵ + x³ + x¹⁹
                expected_n = 756,
                expected_k = 16
            ),
            (
                name = "BB [[784, 24, 24]]",
                l = 28,
                m = 14,
                A = [(:x, 26), (:y, 6), (:y, 8)], # A = x²⁶ + y⁶ + y⁸
                B = [(:y, 7), (:x, 9), (:x, 20)], # B = y⁷ + x⁹ + x²⁰
                expected_n = 784,
                expected_k = 24
            )
        ]
            @testset "$(case.name): l=$(case.l), m=$(case.m)" for case in test_cases
                c = BivariateBicycleViaCirculantMat(case.l, case.m, case.A, case.B)
                stab = parity_checks(c)
                n, k = code_n(c), code_k(c)
                nₛ, kₛ = code_n(stab), code_k(stab)
                H = stab_to_gf2(stab)
                mat = matrix(GF(2), H)
                computed_rank = rank(mat)
                @test computed_rank == n - k && computed_rank == nₛ - kₛ
                @test n == nₛ == case.expected_n && k == kₛ == case.expected_k
                @test stab_looks_good(stab, remove_redundant_rows=true)
                Hxᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
                Hzᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
                @test bivariate_bicycle_code_k(c) == case.expected_k == code_k(c) == 2*c.l*c.m - 2*Hxᵣ == 2*c.l*c.m - 2*Hzᵣ
                # Both A and B are matrices where each row and column has exactly three non-zero entries when using 3-term polynomial representation.
                Hx = parity_matrix_x(c)
                n = size(Hx,2)÷2
                A = Hx[:,1:n]
                B = Hx[:,n+1:end]
                @test all(sum(A, dims=2) .== 3)
                @test all(sum(B, dims=2) .== 3)
                @test all(sum(A, dims=1) .== 3)
                @test all(sum(B, dims=1) .== 3)
                @test A*B == B*A
                @test iszero(A*B+B*A) == iszero(2*A*B)
            end
        end

        @testset "Verify number of logical qubits `k` from Table 1: [berthusen2024toward](@cite)" begin
            test_cases = [
            (
                name = "BB [[72 , 8,6]]",
                l = 12,
                m = 3,
                A = [(:x, 9), (:y, 1), (:y, 2)],
                B = [(:y, 0), (:x, 1), (:x, 11)],
                expected_n = 72,
                expected_k = 8
            ),
            (
                name = "[[90 , 8,6]]",
                l = 9,
                m = 5,
                A = [(:x, 8), (:y, 4), (:y, 1)],
                B = [(:y, 5), (:x, 8), (:x, 7)],
                expected_n = 90,
                expected_k = 8
            ),
            (
                name = "BB [[120, 8, 8]]",
                l = 12,
                m = 5,
                A = [(:x, 10), (:y, 4), (:y, 1)],
                B = [(:y, 0), (:x, 1), (:x, 2)],
                expected_n = 120,
                expected_k = 8
            ),
            (
                name = "BB [[150, 8,8]]",
                l = 15,
                m = 5,
                A = [(:x, 5), (:y, 2), (:y, 3)],
                B = [(:y, 2), (:x, 7), (:x, 6)],
                expected_n = 150,
                expected_k = 8
            ),
            (
                name = "BB [[196,12,8]]",
                l = 14,
                m = 7,
                A = [(:x, 5), (:y, 6), (:y, 5)],
                B = [(:y, 0), (:x, 4), (:x, 13)],
                expected_n = 196,
                expected_k = 12
            )
        ]
            @testset "$(case.name): a=$(case.l), b=$(case.m)" for case in test_cases
                c = BivariateBicycleViaCirculantMat(case.l, case.m, case.A, case.B)
                stab = parity_checks(c)
                n, k = code_n(c), code_k(c)
                nₛ, kₛ = code_n(stab), code_k(stab)
                H = stab_to_gf2(stab)
                mat = matrix(GF(2), H)
                computed_rank = rank(mat)
                @test computed_rank == n - k && computed_rank == nₛ - kₛ
                @test n == nₛ == case.expected_n && k == kₛ == case.expected_k
                @test stab_looks_good(stab, remove_redundant_rows=true)
                Hxᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
                Hzᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
                @test bivariate_bicycle_code_k(c) == case.expected_k == code_k(c) == 2*c.l*c.m - 2*Hxᵣ == 2*c.l*c.m - 2*Hzᵣ
                # Both A and B are matrices where each row and column has exactly three non-zero entries when using 3-term polynomial representation.
                Hx = parity_matrix_x(c)
                n = size(Hx,2)÷2
                A = Hx[:,1:n]
                B = Hx[:,n+1:end]
                @test all(sum(A, dims=2) .== 3)
                @test all(sum(B, dims=2) .== 3)
                @test all(sum(A, dims=1) .== 3)
                @test all(sum(B, dims=1) .== 3)
                @test A*B == B*A
                @test iszero(A*B+B*A) == iszero(2*A*B)
            end
        end

        @testset "Verify number of logical qubits `k` from Table 1: wang2024coprime" begin
            # Test cases from [wang2024coprime](@cite)
            test_cases = [
            (
                name = "BB [[54, 8, 6]]",
                l = 3,
                m = 9,
                A = [(:x, 0), (:y, 2), (:y, 4)],
                B = [(:y, 3), (:x, 1), (:x, 2)],
                expected_n = 54,
                expected_k = 8
            ),
            (
                name = "BB [[98, 6, 12]]",
                l = 7,
                m = 7,
                A = [(:x, 3), (:y, 5), (:y, 6)],
                B = [(:y, 2), (:x, 3), (:x, 5)],
                expected_n = 98,
                expected_k = 6
            ),
            (
                name = "BB [[126, 8, 10]]",
                l = 3,
                m = 21,
                A = [(:x, 0), (:y, 2), (:y, 10)],
                B = [(:y, 3), (:x, 1), (:x, 2)],
                expected_n = 126,
                expected_k = 8
            ),
            (
                name = "BB [[150, 16, 8]]",
                l = 5,
                m = 15,
                A = [(:x, 0), (:y, 6), (:y, 8)],
                B = [(:y, 5), (:x, 1), (:x, 4)],
                expected_n = 150,
                expected_k = 16
            ),
            (
                name = "BB [[162, 8, 14]]",
                l = 3,
                m = 27,
                A = [(:x, 0), (:y, 10), (:y, 14)],
                B = [(:y, 12), (:x, 1), (:x, 2)],
                expected_n = 162,
                expected_k = 8
            ),
            (
                name = "BB [[180, 8, 16]]",
                l = 6,
                m = 15,
                A = [(:x, 3), (:y, 1), (:y, 2)],
                B = [(:y, 6), (:x, 4), (:x, 5)],
                expected_n = 180,
                expected_k = 8
            ),
            (
                name = "BB [[18, 4, 4]]",
                l = 3,
                m = 3,
                A = [(:x, 0), (:x, 1), (:y, 1)],
                B = [(:y, 0), (:x, 2), (:y, 2)],
                expected_n = 18,
                expected_k = 4
            ),
            (
                name = "BB [[36, 4, 6]]",
                l = 3,
                m = 6,
                A = [(:x, 1), (:y, 2), (:y, 3)],
                B = [(:y, 0), (:y, 1), (:x, 2)],
                expected_n = 36,
                expected_k = 4
            ),
            (
                name = "BB [[54, 4, 8]]",
                l = 3,
                m = 9,
                A = [(:x, 1), (:y, 1), (:y, 3)],
                B = [(:y, 0), (:y, 2), (:x, 2)],
                expected_n = 54,
                expected_k = 4
            ),
            (
                name = "BB [[196, 18, 8]]",
                l = 7,
                m = 14,
                A = [(:x, 0), (:y, 1), (:y, 3)],
                B = [(:y, 0), (:x, 2), (:x, 3)],
                expected_n = 196,
                expected_k = 18
            ),

        ]
            @testset "$(case.name): l=$(case.l), m=$(case.m)" for case in test_cases
                c = BivariateBicycleViaCirculantMat(case.l, case.m, case.A, case.B)
                stab = parity_checks(c)
                n, k = code_n(c), code_k(c)
                nₛ, kₛ = code_n(stab), code_k(stab)
                H = stab_to_gf2(stab)
                mat = matrix(GF(2), H)
                computed_rank = rank(mat)
                @test computed_rank == n - k && computed_rank == nₛ - kₛ && n == nₛ && k == kₛ
                @test stab_looks_good(stab, remove_redundant_rows=true)
                Hxᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
                Hzᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
                @test bivariate_bicycle_code_k(c) == case.expected_k == code_k(c) == 2*c.l*c.m - 2*Hxᵣ == 2*c.l*c.m - 2*Hzᵣ
                # Both A and B are matrices where each row and column has exactly three non-zero entries when using 3-term polynomial representation.
                Hx = parity_matrix_x(c)
                n = size(Hx,2)÷2
                A = Hx[:,1:n]
                B = Hx[:,n+1:end]
                @test all(sum(A, dims=2) .== 3)
                @test all(sum(B, dims=2) .== 3)
                @test all(sum(A, dims=1) .== 3)
                @test all(sum(B, dims=1) .== 3)
                @test A*B == B*A
                @test iszero(A*B+B*A) == iszero(2*A*B)
            end
        end

        @testset "4-term polynomial BB [[128, 14, 12]] code from [eberhardt2024logical](@cite)" begin
            l, m = 8, 8
            A = [(:x,2), (:y,1), (:y,3), (:y,4)]
            B = [(:y,2), (:x,1), (:x,3), (:x,4)]
            c = BivariateBicycleViaCirculantMat(l, m, A, B)
            stab = parity_checks(c)
            n, k = code_n(c), code_k(c)
            nₛ, kₛ = code_n(stab), code_k(stab)
            H = stab_to_gf2(stab)
            mat = matrix(GF(2), H)
            computed_rank = rank(mat)
            @test computed_rank == n - k && computed_rank == nₛ - kₛ && n == nₛ && k == kₛ
            @test stab_looks_good(stab, remove_redundant_rows=true)
            Hxᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
            Hzᵣ = rank(matrix(GF(2), parity_matrix_x(c)))
            @test bivariate_bicycle_code_k(c) == code_k(c) == 2*c.l*c.m - 2*Hxᵣ == 2*c.l*c.m - 2*Hzᵣ
            Hx = parity_matrix_x(c)
            n = size(Hx,2)÷2
            A = Hx[:,1:n]
            B = Hx[:,n+1:end]
            @test all(sum(A, dims=2) .== 4)
            @test all(sum(B, dims=2) .== 4)
            @test all(sum(A, dims=1) .== 4)
            @test all(sum(B, dims=1) .== 4)
            @test A*B == B*A
            @test iszero(A*B+B*A) == iszero(2*A*B)
        end
    end
end

@testitem "ECC Hamming" begin

    using QECCore.LinearAlgebra
    using QECCore
    using Nemo: matrix, GF, echelon_form
    using Test

    function minimum_distance(H)
        n = size(H, 2)
        min_dist = n + 1
        for x_bits in 1:(2^n - 1)
            x = reverse(digits(x_bits, base=2, pad=n))
            xᵀ = reshape(x, :, 1)
            if all(mod.(H * xᵀ, 2) .== 0)
                weight = sum(x)
                min_dist = min(min_dist, weight)
            end
        end
        return min_dist
    end

    @testset "Testing Hamming codes properties" begin
        for r in 3:20
            n = 2 ^ r - 1
            k = 2 ^ r - 1 - r
            H = parity_matrix(Hamming(r))
            H = Matrix{Bool}(H)
            mat = matrix(GF(2), parity_matrix(Hamming(r)))
            computed_rank = rank(mat)
            @test computed_rank == n - k
        end
        # minimum distance test is expensive (NP-hard) so we test for r = [3,4]
        r_vals = [3,4]
        for r in r_vals
            H = parity_matrix(Hamming(r))
            H = Matrix{Bool}(H)
            @test minimum_distance(H) == 3
        end
        # Example taken from [huffman2010fundamentals](@cite).
        @test Matrix{Bool}(parity_matrix(Hamming(3))) == [0  0  0  1  1  1  1;
                                                          0  1  1  0  0  1  1;
                                                          1  0  1  0  1  0  1]
    end
end

@testitem "ECC Color Codes" begin
    using QECCore
    using Test
    using Hecke
    using JuMP
    using HiGHS
    using Hecke: group_algebra, GF, abelian_group, gens
    import QuantumClifford.ECC: distance, DistanceMIPAlgorithm

    @testset "Minimum Distance test of Color Codes" begin
        d = [3, 5, 7, 9, 11]
        code_types = [Triangular488, Triangular666]
        for i in d
            for CodeType in code_types
                code_instance = CodeType(i)
                @test distance(code_instance, DistanceMIPAlgorithm(solver=HiGHS)) == i
            end
        end
    end
end

Oscar_flag = false
Tesseract_flag = false
const JET_PROJECT = normpath(joinpath(@__DIR__, "projects", "jet"))
const test_args = isempty(ARGS) ? ["general"] : ARGS
const JET_flag = length(test_args) == 1 && startswith(only(test_args), "jet")
const DOWNGRADE_TEST = get(ENV, "QUANTUMSAVORY_DOWNGRADE_TEST", "") == "true"

if JET_flag
    @info "Activating the dedicated JET test environment." project=JET_PROJECT
    using Pkg
    Pkg.activate(JET_PROJECT)
    Pkg.instantiate()
end

using QECCore
using TestItemRunner

if DOWNGRADE_TEST
    @info "Skipping Oscar tests during the downgrade run."
elseif Sys.iswindows() || Sys.ARCH != :x86_64
    @info "Skipping Oscar tests -- only supported x86_64 *NIX platforms."
else
    Oscar_flag = VERSION >= v"1.11"
    !Oscar_flag && @info "Skipping Oscar tests -- not tested on Julia < 1.11"
    Tesseract_flag = true
end

if DOWNGRADE_TEST
    @info "Skipping Tesseract tests during the downgrade run."
elseif Sys.iswindows()
    @info "Skipping Tesseract tests -- only supported *NIX platforms."
else
    Tesseract_flag = true
end

using Pkg
!JET_flag && Oscar_flag && Pkg.add("Oscar")
!JET_flag && Tesseract_flag && Pkg.add("PyTesseractDecoder")

# filter for the test
testfilter = ti -> begin
    exclude = Symbol[]

    if JET_flag
        return :jet in ti.tags
    else
        push!(exclude, :jet)
    end

    if DOWNGRADE_TEST || !(VERSION >= v"1.10")
        push!(exclude, :doctests)
        push!(exclude, :aqua)
    end

    return all(!in(exclude), ti.tags)
end

println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

@run_package_tests filter=testfilter

@testitem "CSS" begin
    using Test
    using QECCore

    @testset "CSS" begin
        h = QECCore._steane_mat()
        c = CSS(h, h)
        @test parity_matrix(c) == parity_matrix(Steane7())
        @test parity_matrix_x(c) == h
        @test parity_matrix_z(c) == h
    end
end

"""
    $TYPEDEF

Construct a regular LDPC code parity-check matrix `H` using Gallager's
original construction method [gallager1962ldpc](@cite).

# Mathematical Formulation

The parity-check matrix `H` is constructed as:

```math
\\begin{aligned}
H = \\begin{bmatrix} H_1 \\\\ H_2 \\\\ \\vdots \\\\ H_{w_c} \\end{bmatrix}
\\end{aligned}
```

where each submatrix ``H_d`` is a ``μ × μw_r`` binary matrix with:
- Row weight ``w_r`` (number of 1s per row)
- Column weight 1 (each column has exactly one 1)

The first submatrix ``H_1`` has a specific structure where row ``i`` (``1 ≤ i ≤ μ``) contains
its ``w_r`` 1s in columns ``(i-1)w_r + 1`` to ``iw_r``. Subsequent submatrices ``H_2,...,H_{w_c}``
are *column permutations* of ``H_1``.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/gallager).

# Example

Here is an example of `(3,4)`-LDPC code

```jldoctest examples
julia> using QECCore

julia> μ = 3; wc = 3; wr = 4;

julia> H = random_Gallager_ldpc(μ, wc, wr);
```

The Gallager's classical code exhibits regular structure with all columns
having weight 3 and all rows having weight 4, ensuring it maintains constant
column and row weights throughout the parity-check matrix.

```jldoctest examples
julia> all(sum(Matrix(H), dims=1) .== 3)
true

julia> all(sum(Matrix(H), dims=2) .== 4)
true
```

### Arguments
- `block_rows::Int` Number of block rows called "submatrices" in the Gallager's construction [gallager1962ldpc](@cite).
- `col_weight::Int`: Column weight
- `row_weight::Int`: Row weight which must be greater column weight.
"""
function random_Gallager_ldpc(rng::AbstractRNG, block_rows::Int, col_weight::Int, row_weight::Int)
    block_rows ≤ 1 && throw(ArgumentError("Number of block rows must be > 1, got $block_rows"))
    col_weight < 3 && throw(ArgumentError("Column weight must be ≥ 3 (Gallager's condition)"))
    row_weight ≤ 1 && throw(ArgumentError("Row weight must be > 1, got $row_weight"))
    row_weight ≤ col_weight && throw(ArgumentError("Row weight must be > column weight"))
    n = block_rows*row_weight
    m = block_rows*col_weight
    I = Int[]
    J = Int[]
    V = Bool[]
    sizehint!(I, m*col_weight)
    sizehint!(J, m*col_weight)
    sizehint!(V, m*col_weight)
    template_cols = [((i-1)*row_weight+1):(i*row_weight) for i in 1:block_rows]
    perms = [randperm(rng, n) for _ in 2:col_weight]
    for d in 1:col_weight
        rows = ((d-1)*block_rows+1):(d*block_rows)
        if d == 1
            for (i, cols) in enumerate(template_cols)
                for j in cols
                    push!(I, rows[i])
                    push!(J, j)
                    push!(V, true)
                end
            end
        else
            perm = perms[d-1]
            for (i, cols) in enumerate(template_cols)
                for j in cols
                    push!(I, rows[i])
                    push!(J, perm[j])
                    push!(V, true)
                end
            end
        end
    end
    H = sparse(I, J, V, m, n)
    return H
end

random_Gallager_ldpc(block_rows::Int, col_weight::Int, row_weight::Int) = random_Gallager_ldpc(GLOBAL_RNG, block_rows, col_weight, row_weight)

"""
Represents a *bipartite* Tanner graph used in classical coding theory. It connects *variable
nodes* (codeword bits or qubits) to *check nodes* (parity constraints) and serves as the
foundation for constructing Tanner graphs in quantum CSS codes.
"""
struct BipartiteGraph
    """The underlying undirected graph (from `Graphs.jl`)."""
    g::Graph
    """Indices of variable nodes."""
    var_nodes::Vector{Int}
    """Indices of check nodes."""
    check_nodes::Vector{Int}
end

"""
Constructs a *Tanner graph* from a given parity-check matrix `H`, where rows correspond to *check nodes*
and columns to *variable nodes*. The resulting *bipartite* graph indexes variable nodes as `1:n` and check
nodes as `n+1:n+m` for an `m × n` matrix `H`."""
function tanner_graph_from_parity_matrix(H::AbstractMatrix)
    m, n = size(H)
    g = SimpleGraph(n + m)
    var_nodes = collect(1:n)
    check_nodes = collect(n+1:n+m)
    for row in 1:m, col in 1:n
        H[row, col] && add_edge!(g, col, n + row)
    end
    return BipartiteGraph(g, var_nodes, check_nodes)
end

"""Reconstructs the parity-check matrix from a Tanner graph `g`.

!!! note
    The first block of vertices corresponds to variable nodes and the remaining to check nodes. It
    returns a parity check matrix `H` of size `(number of check nodes) × (number of variable nodes).`
"""
function parity_matrix_from_tanner_graph(bg::BipartiteGraph)
    n_vars = length(bg.var_nodes)
    n_checks = length(bg.check_nodes)
    H = spzeros(Bool, n_checks, n_vars)
    for (check_idx, check_node) in enumerate(bg.check_nodes)
        for neighbor in neighbors(bg.g, check_node)
            neighbor in bg.var_nodes && (H[check_idx, neighbor] = true)
        end
    end
    return H
end

"""
Constructs a bipartite Tanner graph representing the cycle code of length `n`. The graph
consists of `n` variable nodes and `n` check nodes, totaling `2n` nodes. Each check node `i`
(for `i` in `1...n`) connects to variable nodes `i` and (``i+1 \\mod n``). This results in a
parity-check matrix `H`, where each row contains exactly two `1`s, encoding the edges of a
length-`n` cycle.
"""
function cycle_tanner_graph(n::Int)
    g = SimpleGraph(2n)
    var_nodes = collect(1:n)
    check_nodes = collect(n+1:2n)
    for i in 1:n
        check_node = n + i
        add_edge!(g, i, check_node)
        add_edge!(g, mod1(i+1, n), check_node)
    end
    return BipartiteGraph(g, var_nodes, check_nodes)
end

"""
    $TYPEDEF

Represents the CSS quantum code `Q(G₁ × G₂)` constructed from two binary codes with
parity-check matrices `H₁` and `H₂`, using the hypergraph product formulation introduced
by [tillich2013quantum](@cite).

This construction corresponds to a specific product of Tanner graphs:
- Let `G₁ = T(V₁, C₁, E₁)` and `G₂ = T(V₂, C₂, E₂)` be the Tanner graphs of `H₁` and `H₂`.
- The product graph `G₁ × G₂` has vertex set `(V₁ × V₂) ∪ (C₁ × C₂)` and check set `(C₁ × V₂) ∪ (V₁ × C₂)`.
- The Tanner subgraphs `G₁ ×ₓ G₂` and `G₁ ×𝓏 G₂` define classical codes `Cₓ` and `C𝓏` used in the CSS construction.

The `hgp(H₁, H₂)` function algebraically realizes this graph-theoretic product using Kronecker operations,
yielding the `X`- and `Z`-type parity-check matrices:

- `H_X = [H₁ ⊗ I  |  I ⊗ H₂ᵗ]` corresponds to `G₁ ×ₓ G₂`
- `H_Z = [I ⊗ H₂  |  H₁ᵗ ⊗ I]` corresponds to `G₁ ×𝓏 G₂`

These matrices ensure `H_X * H_Zᵗ = 0`, satisfying the CSS condition.

See: [tillich2013quantum](@cite), Section 4.3 — “The hypergraph connection, product codes”

# 𝑄(𝐺₁ × 𝐺₂)

The `𝑄(𝐺₁ × 𝐺₂)` quantum LDPC codes represent a broader generalization of **quantum expander codes**
which are derived from the Leverrier-Tillich-Zémor construction [tillich2013quantum](@cite).

```jldoctest examples
julia> using QuantumClifford; using QuantumClifford.ECC; using QECCore

julia> H1 = [1 0 1 0; 0 1 0 1; 1 1 0 0];

julia> H2 = [1 1 0; 0 1 1];

julia> c = parity_checks(QuantumTannerGraphProduct(H1, H2))
+ X_____X_____X_____
+ _X_____X____XX____
+ __X_____X____X____
+ ___X_____X____X___
+ ____X_____X___XX__
+ _____X_____X___X__
+ X__X____________X_
+ _X__X___________XX
+ __X__X___________X
+ ZZ__________Z___Z_
+ _ZZ__________Z___Z
+ ___ZZ_________Z_Z_
+ ____ZZ_________Z_Z
+ ______ZZ____Z_____
+ _______ZZ____Z____
+ _________ZZ___Z___
+ __________ZZ___Z__

julia>  code_n(c), code_k(c)
(18, 1)
```

# Quantum Expander code

The `𝑄(𝐺₁ × 𝐺₂)` code is more general than the **standard quantum expander code**
[leverrier2015quantum](@cite) construction. The quantum expander code construction
corresponds to the specific case where `G = G1 = G2`​.

```jldoctest examples
julia> H = parity_matrix(RepCode(3));

julia> c = parity_checks(QuantumTannerGraphProduct(H, H))
+ X__X_____X_X______
+ _X__X____XX_______
+ __X__X____XX______
+ ___X__X_____X_X___
+ ____X__X____XX____
+ _____X__X____XX___
+ X_____X________X_X
+ _X_____X_______XX_
+ __X_____X_______XX
+ ZZ_______Z_____Z__
+ _ZZ_______Z_____Z_
+ Z_Z________Z_____Z
+ ___ZZ____Z__Z_____
+ ____ZZ____Z__Z____
+ ___Z_Z_____Z__Z___
+ ______ZZ____Z__Z__
+ _______ZZ____Z__Z_
+ ______Z_Z_____Z__Z

julia>  code_n(c), code_k(c)
(18, 2)
```

### Fields
    $TYPEDFIELDS

See also: [`CyclicQuantumTannerGraphProduct`](@ref), [`hgp`](@ref)
"""
struct QuantumTannerGraphProduct <: AbstractCSSCode
    """The first classical seed code for the the quantum tanner graph code."""
    H1::AbstractMatrix
    """The second classical seed code for the the quantum tanner graph code."""
    H2::AbstractMatrix
end

parity_matrix_xz(c::QuantumTannerGraphProduct) = hgp(c.H1, c.H2)

"""
    $TYPEDEF

Constructs a `𝑄(𝐺₁ × 𝐺₂)` quantum Tanner graph product code using cyclic Tanner graphs of length `2m`.

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC;

julia> m = 1;

julia> c = parity_checks(CyclicQuantumTannerGraphProduct(m))
+ X_X_XX__
+ _X_XXX__
+ X_X___XX
+ _X_X__XX
+ ZZ__Z_Z_
+ ZZ___Z_Z
+ __ZZZ_Z_
+ __ZZ_Z_Z

julia> code_n(c), code_k(c)
(8, 2)

julia> m = 10;

julia> c = parity_checks(CyclicQuantumTannerGraphProduct(m));

julia> code_n(c), code_k(c)
(800, 2)
```

### Fields
    $TYPEDFIELDS
"""
struct CyclicQuantumTannerGraphProduct <: AbstractCSSCode
    m::Int
    function CyclicQuantumTannerGraphProduct(m::Int)
        m > 0 || throw(ArgumentError("m must be positive."))
        new(m)
    end
end

function parity_matrix_xz(Q::CyclicQuantumTannerGraphProduct)
    n = 2*Q.m
    G1 = cycle_tanner_graph(n)
    G2 = cycle_tanner_graph(n)
    H1 = parity_matrix_from_tanner_graph(G1)
    H2 = parity_matrix_from_tanner_graph(G2)
    return hgp(H1, H2)
end

parity_matrix_x(c::Union{QuantumTannerGraphProduct,CyclicQuantumTannerGraphProduct}) = parity_matrix_xz(c)[1]

parity_matrix_z(c::Union{QuantumTannerGraphProduct,CyclicQuantumTannerGraphProduct}) = parity_matrix_xz(c)[2]

"""
    $TYPEDEF

A construction of the Reed-Muller class of codes using the recursive definition.

The Plotkin `(u, u + v)` construction defines a recursive relation between generator matrices of Reed-Muller `(RM)` codes [abbe2020reed](@cite). To derive the generator matrix `G(m, r)` for `RM(r, m)`, the generator matrices of lower-order codes are utilized:
- `G(r - 1, m - 1)`: Generator matrix of `RM(r - 1, m - 1)`
- `G(r, m - 1)`: Generator matrix of `RM(r, m - 1)`

The generator matrix `G(m, r)` of `RM(m, r)` is formulated as follows in matrix notation:

```math
G(m, r) = \begin{bmatrix}
G(r, m - 1) & G(r, m - 1) \\
0 & G(r - 1, m - 1)
\end{bmatrix}
```

Here, the matrix 0 denotes an all-zero matrix with dimensions matching `G(r - 1, m - 1)`. This recursive approach facilitates the construction of higher-order Reed-Muller codes based on the generator matrices of lower-order codes.

In addition, the dimension of `RM(m - r - 1, m)` equals the dimension of the dual of `RM(r, m)`. Thus, `RM(m - r - 1, m) = RM(r, m)^⊥` shows that the [dual code](https://en.wikipedia.org/wiki/Dual_code) of `RM(r, m)` is `RM(m − r − 1, m)`, indicating the parity check matrix of `RM(r, m)` is the generator matrix for `RM(m - r - 1, m)`.

See also: [`ReedMuller`](@ref) and [`QuantumReedMuller`](@ref)

### Fields
    $TYPEDFIELDS
"""
struct RecursiveReedMuller <: AbstractCECC
    """The order of the code."""
    r::Int
    """The log-length of the code."""
    m::Int

    function RecursiveReedMuller(r, m)
        if r < 0 || r > m
            throw(ArgumentError("Invalid parameters: r must be non-negative and r ≤ m in order to valid code."))
        end
        new(r, m)
    end
end

function _recursiveReedMuller(r::Int, m::Int)
    if r == 1 && m == 1
        return Matrix{Int}([1 1; 0 1])
    elseif r == m
        return Matrix{Int}(I, 2^m, 2^m)
    elseif r == 0
        return Matrix{Int}(ones(1, 2^m))
    else
        Gᵣₘ₋₁ = _recursiveReedMuller(r, m - 1)
        Gᵣ₋₁ₘ₋₁ = _recursiveReedMuller(r - 1, m - 1)
        return vcat(hcat(Gᵣₘ₋₁, Gᵣₘ₋₁), hcat(zeros(Int, size(Gᵣ₋₁ₘ₋₁)...), Gᵣ₋₁ₘ₋₁))
    end
end

function generator(c::RecursiveReedMuller)
    return _recursiveReedMuller(c.r, c.m)
end

function parity_matrix(c::RecursiveReedMuller)
    H = generator(RecursiveReedMuller(c.m - c.r - 1, c.m))
    return H
end

code_n(c::RecursiveReedMuller) = 2 ^ c.m

code_k(c::RecursiveReedMuller) = sum(binomial.(c.m, 0:c.r))

distance(c::RecursiveReedMuller) = 2 ^ (c.m - c.r)

rate(c::RecursiveReedMuller) = code_k(c::RecursiveReedMuller) / code_n(c::RecursiveReedMuller)

"""Goppa codes [goppa1970new](@cite)."""
function Goppa(args...; kwargs...)
    ext = Base.get_extension(QECCore, :QECCoreNemoExt)
    if isnothing(ext)
        throw("The `Goppa` depends on the package `Nemo` but you have not installed or imported it yet. Immediately after you import `Nemo`, the `Goppa` will be available.")
    end
    return ext.Goppa(args...; kwargs...)
end

function random_Goppa_code end

"""
    $TYPEDEF

The family of `[2ʳ - 1, 2ʳ - 1 - r, 3]` Hamming binary codes were discovered
by Richard W. Hamming in his 1950 paper [hamming1950error](@cite) as a way of
automatically correcting errors introduced by punched card readers. In his
original paper, Hamming elaborated his general idea, but specifically focused
on the `Hamming(7, 4)` code which adds three parity bits to four bits of data.

The Hamming matrix `H` is an `r × (2ʳ - 1)` binary matrix, where each column
corresponds to the binary representation of the integers from 1 to 2ʳ - 1, with
`r ≥ 2`. This matrix serves as the parity-check matrix for a binary Hamming code
with parameters `[2ʳ − 1, 2ʳ − 1 − r, 3]` The minimum Hamming distance of this
code is 3, as detailed in [huffman2010fundamentals](@cite).

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/hamming).

### Fields
    $TYPEDFIELDS
"""
struct Hamming <: AbstractCECC
    r::Int
    function Hamming(r)
        if r < 2
            throw(ArgumentError("Invalid parameters: `r` must be ≥ 2 to obtain a valid code."))
        end
        new(r)
    end
end

function parity_matrix(h::Hamming)
    n = 2^h.r - 1
    max_elem = n * h.r
    rows = Vector{Int}(undef, max_elem)
    cols = Vector{Int}(undef, max_elem)
    vals = Vector{Int}(undef, max_elem)
    idx = 1
    @inbounds for j in 1:n
        mask = 1 << (h.r - 1)
        @simd for i in 1:h.r
            if j & mask != 0
                rows[idx] = i
                cols[idx] = j
                vals[idx] = 1
                idx += 1
            end
            mask >>= 1
        end
    end
    rows = rows[1:idx-1]
    cols = cols[1:idx-1]
    vals = vals[1:idx-1]
    return sparse(rows, cols, vals, h.r, n)
end

code_n(h::Hamming) = 2 ^ h.r - 1

code_k(h::Hamming) = 2 ^ h.r - 1 - h.r

distance(h::Hamming) = 3

@testitem "RepCode" begin
    using Test
    using QECCore

    @testset "RepCode" begin
        c = RepCode(5)
        @test parity_matrix(c) == Bool[1 1 0 0 0;
                                    0 1 1 0 0;
                                    0 0 1 1 0;
                                    0 0 0 1 1;
                                    1 0 0 0 1]
        @test code_n(c) == 5
        @test code_s(c) == 5
    end

    @testset "Bitflip3" begin
        c = Bitflip3()
        @test parity_matrix(c) == Bool[0 0 0 1 1 0;
                                    0 0 0 0 1 1]
    end

    @testset "Phaseflip3" begin
        c = Phaseflip3()
        @test parity_matrix(c) == Bool[1 1 0 0 0 0;
                                    0 1 1 0 0 0]
    end
end

module QECCoreNemoExt

using QECCore
using DocStringExtensions

import Nemo
import Nemo: GF, matrix, rank, transpose, finite_field, GF, polynomial_ring, evaluate,
    FqFieldElem, FqPolyRingElem, degree, is_irreducible, gcd, derivative, matrix, inv,
    is_zero, coeff, is_monic, one

import QECCore: code_k, parity_matrix_x, parity_matrix_z, parity_matrix, generator_polynomial

import Random
import Random: MersenneTwister, GLOBAL_RNG, AbstractRNG, rand

import QECCore: random_Goppa_code, code_k, code_n

function QECCore.code_k(c::AbstractCSSCode)
    n = code_n(c)
    F₂ = GF(2)
    rank_Hx = rank(matrix(F₂, parity_matrix_x(c)))
    rank_Hz = rank(matrix(F₂, parity_matrix_z(c)))
    return n - rank_Hx - rank_Hz
end

function QECCore.code_k(c::AbstractCECC)
    H = Matrix(parity_matrix(c))
    n = code_n(c)
    F₂ = GF(2)
    rank_H = rank(matrix(F₂, H))
    return n - rank_H
end

include("goppa.jl")

end # module

"""
    $TYPEDEF

The family of Goppa codes, as discovered by Denisovich Goppa, in his 1970 paper [goppa1970new](@cite). The
binary Goppa code is characterized by two key elements:

- Goppa polynomial: A *monic* polynomial of degree t over ``\\mathbb{F}_{2^m}`` with no repeated roots. For a fixed support set ``L = {\\gamma_0, \\dots, \\gamma_{n-1}} \\subseteq \\mathbb{F}_{2^m}``, the polynomial satisfies ``g(\\gamma_i) \\neq 0`` for all ``0 \\leq i < n``.
- Support list: A list of n distinct elements ``{\\gamma_0, \\dots, \\gamma_{n-1}}`` from ``\\mathbb{F}_{2^m}`` such that ``g(\\gamma_i) \\neq 0`` for all ``0 \\leq i < n`` (i.e., none are roots of the Goppa polynomial g(x).

The set ``L = {\\gamma_0, \\dots, \\gamma_{n-1}}`` defines the code’s structure, with n distinct
elements from ``\\mathbb{F}_{2^m}``. The Goppa polynomial g(x) is irreducible over ``\\mathbb{F}_{2^m}``
and satisfy ``g(\\gamma_i) \\neq 0)`` for all ``(\\gamma_i \\in L``. The parity-check matrix H of
an binary Goppa code can be broken down into product of three simpler matrices:

## Vandermonde Matrix

Each row of V is constructed using the elements from the support list L raised to different powers.

```math
\\begin{matrix}
1                & 1                  & 1                & \\cdots & 1 \\\\
(L_1)^1          & (L_2)^1            & (L_3)^1          & \\cdots & (L_n)^1 \\\\
(L_1)^2          & (L_2)^2            & (L_3)^2          & \\cdots & (L_n)^2 \\\\
\\vdots          & \\vdots            & \\vdots          & \\ddots & \\vdots \\\\
(L_1)^{t-1}      & (L_2)^{t-1}        & (L_3)^{t-1}      & \\cdots & (L_n)^{t-1}
\\end{matrix}
```

## Diagonal Matrix

Each diagonal element in D is related to the roots of the Goppa polynomial g(x).

```math
\\begin{bmatrix}
\\frac{1}{g(L_1)} & 0               & 0                 & \\cdots & 0 \\\\
0               & \\frac{1}{g(L_2)} & 0                 & \\cdots & 0 \\\\
0               & 0                 & \\frac{1}{g(L_3)} & \\cdots & 0 \\\\
\\vdots         & \\vdots           & \\vdots           & \\ddots & \\vdots \\\\
0               & 0                 & 0                 & \\cdots & \\frac{1}{g(L_n)}
\\end{bmatrix}
```

## X Matrix

Each element in X is related to the coefficients of the Goppa polynomial g(x).

```math
\\begin{bmatrix}
g_t           & 0             & 0             & \\cdots & 0 \\\\
g_{t-1}       & g_t           & 0             & \\cdots & 0 \\\\
g_{t-2}       & g_{t-1}       & g_t           & \\cdots & 0 \\\\
\\vdots       & \\vdots       & \\vdots       & \\ddots & \\vdots \\\\
g_1           & g_2           & g_3           & \\cdots & g_t
\\end{bmatrix}
```

The matrix V*D can be viewed as parity check matrix for Γ(L, g) over ``\\mathbb{F}_{2^m}``:

```math
\\begin{bmatrix}
1 \\cdot g(L_1)^{-1}       & 1 \\cdot g(L_2)^{-1}       & 1 \\cdot g(L_3)^{-1}       & \\cdots & 1 \\cdot g(L_n)^{-1} \\\\
L_1 \\cdot g(L_1)^{-1}     & L_2 \\cdot g(L_2)^{-1}     & L_3 \\cdot g(L_3)^{-1}     & \\cdots & L_n \\cdot g(L_n)^{-1} \\\\
L_1^2 \\cdot g(L_1)^{-1}   & L_2^2 \\cdot g(L_2)^{-1}   & L_3^2 \\cdot g(L_3)^{-1}   & \\cdots & L_n^2 \\cdot g(L_n)^{-1} \\\\
\\vdots                    & \\vdots                    & \\vdots                    & \\ddots & \vdots \\\\
L_1^{t-1} \\cdot g(L_1)^{-1} & L_2^{t-1} \\cdot g(L_2)^{-1} & L_3^{t-1} \\cdot g(L_3)^{-1} & \\cdots & L_n^{t-1} \\cdot g(L_n)^{-1}
\\end{bmatrix}
```

!!! note
    The entries of matrix over field elements are in ``\\mathbb{F}_{2^m}``. Each element in
    ``\\mathbb{F}_{2^m}`` can be represented by a m-tuple/binary column vector of length m.
    If each entry of H is replaced by its corresponding m-tuple/binary column vector of length
    m over ``\\mathbb{F}_{2^m}``, we obtain a binary parity check matrix for the goppa code.

You might be interested in consulting [berlekamp1973goppa](@cite), [mceliece1978public](@cite),
[patterson1975algebraic](@cite), [sugiyama1975method](@cite), [van1988classical](@cite),
[bernstein2008attacking](@cite), [wirtz1988parameters](@cite) and [singh2019code](@cite)
an as well.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/gappa).

!!! note
    In Nemo, taking a random monic poly of degree `n`, this poly is irreducible with
    probability `1/n`. One in `n` monic polynomials is, on average irreducible. To increase
    probability of success of getting irreducible polynomial, use more iterations.

### Example

Here is an example of `[8, 2, d]` Goppa code from [slides](https://crypto-kantiana.com/elena.kirshanova/talks/Talk_McEliece.pdf).

```jldoctest
julia> using QECCore; using Nemo

julia> t = 2;

julia> m = 3;

julia> F = GF(2, m, :α);

julia> α = gen(F);

julia> R, x = polynomial_ring(F, :x);

julia> g = x^t + x + 1;

julia> L = [F(0), F(1), α, α^2, α + 1, α^2 + α, α^2 + α + 1, α^2 + 1];

julia> c = Goppa(m, t, g, L);

julia> code_n(c), code_k(c)
(8, 2)
```

If no support set L is specified, it defaults to all non-roots of g(x) in ``\\mathbb{F}_{2^m}``

```math
\\begin{aligned}
L = { \\alpha \\in \\mathbb{F}_{2^m} \\mid g(\\alpha) \\neq 0}
\\end{aligned}
```

```jldoctest
julia> import Nemo: polynomial_ring, rank, matrix, GF;

julia> using QECCore: random_Goppa_code, code_n, code_k, parity_matrix; using Random: MersenneTwister;

julia> rng = MersenneTwister(123);

julia> m, t = 5, 4;

julia> c = random_Goppa_code(rng, m, t);

julia> c.g
x^4 + (α^3 + α^2 + α + 1)*x^3 + (α + 1)*x^2 + (α^3 + 1)*x + α^4 + α^3 + α^2 + α

julia> H = parity_matrix(c);

julia> size(H, 2), size(H, 2) - rank(matrix(GF(2), H))
(32, 12)
```

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/goppa).

### Fields
    $TYPEDFIELDS
"""
struct Goppa <: AbstractPolynomialCode
    """ The extension degree of ``\\mathbb{F}_{2^m}`` which determines the size of the field
    (2^m elements) and the binary expansion length."""
    m::Int
    """The degree of the Goppa polynomial `g(x)` which controls the error-correction capability."""
    t::Int
    """The Goppa polynomial over ``\\mathbb{F}_{2^m}`` which must satisfy: degree(g) = t, and
    g(αᵢ) ≠ 0 ∀ αᵢ ∈ L."""
    g::FqPolyRingElem
    """The support set of distinct elements from ``\\mathbb{F}_{2^m}`` which defines code length
    n = length(L). It must satisfy g(α) ≠ 0 ∀ α ∈ L."""
    L::Vector{FqFieldElem}

    function Goppa(m::Int, t::Int, g::FqPolyRingElem, L::Vector{FqFieldElem})
        (m < 3 || t < 2 || t >= 2^(m - 1)) && throw(ArgumentError("m ≥ 3 and t ≥ 2 required, with t < 2^(m-1)"))
        degree(g) != t && throw(ArgumentError("The Goppa polynomial must have degree t"))
        !is_monic(g) && throw(ArgumentError("The Goppa polynomial must be monic."))
        any(evaluate(g, α) == 0 for α in L) && throw(ArgumentError("L cannot contain roots of the Goppa polynomial."))
        length(L) - m*t ≤ 0 && throw(ArgumentError("Parameters would produce invalid code: length(L) - m*t = $(length(L)) - $m*$t ≤ 0."))
        new(m, t, g, L)
    end
end

function Goppa(m::Int, t::Int, g::FqPolyRingElem)
    F = GF(2, m, :α)
    L = [a for a in F if evaluate(g, a) != 0]
    return Goppa(m, t, g, L)
end

function QECCore.random_Goppa_code(rng::AbstractRNG, m::Int, t::Int)
    (m < 3 || t < 2 || t >= 2^(m - 1)) && throw(ArgumentError("m ≥ 3 and t ≥ 2 required, with t < 2^(m-1)"))
    F = GF(2, m, :α)
    R, x = polynomial_ring(F, :x)
    for _ in 1:500
        coeffs = rand(rng, F, t)
        g = R([coeffs...; one(F)])
        if is_irreducible(g)
            L = [a for a in F if evaluate(g, a) != 0]
            if length(L) - m*t > 0
                return Goppa(m, t, g, L)
            end
        end
    end
    throw(ErrorException("Failed to find suitable irreducible polynomial after 500 attempts"))
end

QECCore.random_Goppa_code(m::Int, t::Int) = QECCore.random_Goppa_code(GLOBAL_RNG, m, t)

function parity_matrix(ga::Goppa)
    m, t, g, L = ga.m, ga.t, ga.g, ga.L
    F = parent(L[1])
    # D = diag(1/g(oᵢ))
    Dᵢₙᵥ = [inv(evaluate(g, o_i)) for o_i in L]
    # V = [oᵢʲ⁻¹]
    V = [o_i^(j-1) for j in 1:ga.t, o_i in L]
    H_poly = [V[i,j] * Dᵢₙᵥ[j] for i in 1:ga.t, j in 1:length(L)]
    H = Matrix{Bool}(undef, ga.m * ga.t, length(L))
    for i in 1:ga.t
        row_range = (i-1)*ga.m+1 : i*ga.m
        for j in 1:length(L)
            H[row_range, j] .= [coeff(H_poly[i,j], k) != 0 for k in 0:ga.m-1]
        end
    end
    return H
end

generator_polynomial(c::Goppa) = c.g

"""
    $TYPEDEF

The `[[4p, 2(p − 2), 4]]` Delfosse-Reichardt repetition code is derived from the
classical `[4, 1, 4]` repetition code and is used to construct quantum stabilizer code.

The `[4, 1, 4]` repetition code is a classical error-correcting code where each bit
is repeated four times to improve error detection and correction. It is defined by
the following parity-check matrix:

```math
\\begin{pmatrix}
1 & 1 & 1 & 1 \\\\
0 & 0 & 1 & 1 \\\\
0 & 1 & 0 & 1
\\end{pmatrix}
```

The `[[4p, 2(p − 2), 4]]` codes were introduced by Delfosse and Reichardt in the
paper *Short Shor-style syndrome sequences* [delfosse2020short](@cite). The parameter
`p` specifies the **number of blocks** in the code construction. For the code to be
valid, `p` must be a multiple of 2.

An `[[24, 8, 4]]` Delfosse-Reichardt repetition code from [delfosse2020short](@cite).

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC # hide

julia> p = 6;

julia> c = parity_checks(DelfosseReichardtRep(p))
+ XXXX____________________
+ ____XXXX________________
+ ________XXXX____________
+ ____________XXXX________
+ ________________XXXX____
+ ____________________XXXX
+ __XX__XX__XX__XX__XX__XX
+ _X_X_X_X_X_X_X_X_X_X_X_X
+ ZZZZ____________________
+ ____ZZZZ________________
+ ________ZZZZ____________
+ ____________ZZZZ________
+ ________________ZZZZ____
+ ____________________ZZZZ
+ __ZZ__ZZ__ZZ__ZZ__ZZ__ZZ
+ _Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z

julia> code_n(c), code_k(c)
(24, 8)
```

### Fields
    $TYPEDFIELDS


See also: [`DelfosseReichardt`](@ref), [`DelfosseReichardt823`](@ref)
"""
struct DelfosseReichardtRep <: AbstractCSSCode
    """The number of blocks in the Delfosse-Reichardt Repetition code."""
    p::Int
    function DelfosseReichardtRep(p)
        p < 2 && throw(ArgumentError("The number of blocks must be at least 2 to construct a valid code."))
        p % 2 != 0 && throw(ArgumentError("The number of blocks must be a multiple of 2."))
        new(p)
    end
end

function _extend_414_repetition_code(p::Int)
    n = 4*p
    H = zeros(Bool, 2+p, n)
    @inbounds @simd for i in 1:p
        H[i, (4*(i-1)+1):(4*i)] .= 1
    end
    @inbounds @simd for i in 1:p
        H[p+1, (4*(i-1)+3):(4*(i-1)+4)] .= 1
    end
    @inbounds @simd for i in 1:p
        H[p+2, (4*(i-1)+2):(4*(i-1)+4):2] .= 1
    end
    H[end, 1:n] .= (1:n) .% 2 .== 0
    return H
end

function parity_matrix_xz(c::DelfosseReichardtRep)
    extended_mat = _extend_414_repetition_code(c.p)
    return extended_mat, extended_mat
end

parity_matrix_x(c::DelfosseReichardtRep) = parity_matrix_xz(c)[1]

parity_matrix_z(c::DelfosseReichardtRep) = parity_matrix_xz(c)[2]

code_n(c::DelfosseReichardtRep) = 4*c.p

code_k(c::DelfosseReichardtRep) = 2*(c.p - 2)

distance(c::DelfosseReichardtRep) = 4

"""
The family of Bose–Chaudhuri–Hocquenghem (BCH) codes, as discovered in 1959 by
Alexis Hocquenghem [hocquenghem1959codes](@cite), and independently in 1960 by
Raj Chandra Bose and D.K. Ray-Chaudhuri [bose1960class](@cite).

The BCH code, denoted as `BCH(m, t)`, is defined by `m`, a positive integer that
specifies the degree of the finite (Galois) field `GF(2ᵐ)`, and `t`, a positive
integer that indicates the number of correctable errors. The binary parity check
matrix can be obtained from the following matrix over ``GF(2ᵐ)`` field elements:

```math
\\begin{aligned}
\\begin{matrix}
1 & (\\alpha^1)^1 & (\\alpha^1)^2 & (\\alpha^1)^3 & \\dots & (\\alpha^1)^{n-1} \\\\
1 & (\\alpha^3)^1 & (\\alpha^3)^2 & (\\alpha^3)^3 & \\dots & (\\alpha^3)^{n-1} \\\\
1 & (\\alpha^5)^1 & (\\alpha^5)^2 & (\\alpha^5)^3 & \\dots & (\\alpha^5)^{n-1} \\\\
\\vdots & \\vdots & \\vdots & \\vdots & \\ddots & \\vdots \\\\
1 & (\\alpha^{2t-1})^1 & (\\alpha^{2t-1})^2 & (\\alpha^{2t-1})^3 & \\dots & (\\alpha^{2t-1})^{n-1}
\\end{matrix}
\\end{aligned}
```

The entries of the matrix are in `GF(2ᵐ)`. Each element in `GF(2ᵐ)` can be represented
by an `m`-tuple (a binary column vector of length `m`). If each entry of `H` is replaced
by its corresponding `m`-tuple, we obtain a binary parity check matrix for the code.

The BCH code is cyclic as its generator polynomial, `g(x)` divides `xⁿ - 1`, so
`mod (xⁿ - 1, g(x)) = 0`.

You might be interested in consulting [bose1960further](@cite) and [error2024lin](@cite)
as well.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/q-ary_bch).
"""
struct BCH <: AbstractPolynomialCode
    m::Int
    t::Int
    function BCH(m, t)
        m < 3 && throw(ArgumentError("m must be greater than or equal to 3"))
        t >= 2^(m - 1) && throw(ArgumentError("t must be less than 2ᵐ ⁻ ¹"))
        m * t > 2^m - 1 && throw(ArgumentError("m*t must be less than or equal to 2ᵐ - 1"))
        new(m, t)
    end
end

code_n(b::BCH) = 2 ^ b.m - 1

"""
Generator Polynomial of BCH Codes

This function calculates the generator polynomial `g(x)` of a `t`-bit error-correcting
BCH code of binary length `n = 2ᵐ - 1`. The binary code is derived from a code over the
finite Galois field `GF(2ᵐ)`.

The generator polynomial `g(x)` is the fundamental polynomial used for encoding and
decoding BCH codes. It has the following properties:

- Roots: It has `α`, `α²`, `α³`, ..., `α²ᵗ` as its roots, where `α` is a primitive element
of the Galois Field `GF(2ᵐ)`.
- Error Correction: A BCH code with generator polynomial `g(x)` can correct up to `t` errors
in a codeword of length `2ᵐ - 1`.
- Minimal Polynomials: `g(x)` is the least common multiple (LCM) of the minimal polynomials
`φᵢ(x)` of `αⁱ` for `i` from `1` to `2ᵗ`.

Useful definitions and background:

Minimal Polynomial: The minimal polynomial of a field element `α` in GF(2ᵐ) is the polynomial
of the lowest degree over `GF(2ᵐ)` that has `α` as a root.

Least Common Multiple (LCM): The LCM of two or more polynomials `fᵢ(x)` is the polynomial
with the lowest degree that is a multiple of all `fᵢ(x)`. It ensures that `g(x)` has all
the roots of `φᵢ(x)` for `i = 1` to `2ᵗ`.

Conway polynomial: The finite Galois field `GF(2ᵐ)` can have multiple distinct primitive
polynomials of the same degree due to existence of several irreducible polynomials of that
degree, each generating the field through different roots.

Nemo.jl uses [Conway polynomial](https://en.wikipedia.org/wiki/Conway_polynomial_(finite_fields)),
a standard way to represent the primitive polynomial for finite Galois fields `GF(pᵐ)` of degree
`m`, where `p` is a prime number.
"""
function generator_polynomial(b::BCH)
    GF2ʳ, a = finite_field(2, b.m, "a")
    GF2x, x = GF(2)["x"]
    minimal_poly = FqPolyRingElem[]
    for i in 1:2 * b.t
        if i % 2 != 0
            push!(minimal_poly, minpoly(GF2x, a ^ i))
        end
    end
    gx = lcm(minimal_poly)
    return gx
end

function parity_matrix(b::BCH)
    GF2ʳ, a = finite_field(2, b.m, "a")
    HField = Matrix{FqFieldElem}(undef, b.t, 2 ^ b.m - 1)
    for i in 1:b.t
        for j in 1:2 ^ b.m - 1
            base = 2 * i - 1
            HField[i, j] = (a ^ base) ^ (j - 1)
        end
    end
    H = Matrix{Bool}(undef, b.m * b.t, 2 ^ b.m - 1)
    for i in 1:b.t
        row_start = (i - 1) * b.m + 1
        row_end = row_start + b.m - 1
        for j in 1:2 ^ b.m - 1
            t_tuple = Bool[]
            for k in 0:b.m - 1
                push!(t_tuple, !is_zero(coeff(HField[i, j], k)))
            end
            H[row_start:row_end, j] .=  vec(t_tuple')
        end
    end
    return H
end

code_k(b::BCH) = 2 ^ b.m - 1 - degree(generator_polynomial(BCH(b.m, b.t)))

"""
    $TYPEDEF

`Bitflip3` is a three-qubit bit-flip code that corrects single-qubit bit-flip error and does not detect any phase-flip errors.
"""
struct Bitflip3 <: AbstractQECC end

parity_matrix(c::Bitflip3) = hcat(zeros(Bool,2,3), parity_matrix(RepCode(3))[1:2,:])

"""
    $TYPEDEF

`Phaseflip3` is a three-qubit phase-flip code that corrects single-qubit phase-flip error and does not detect any bit-flip errors.
"""
struct Phaseflip3 <: AbstractQECC end

parity_matrix(c::Phaseflip3) = hcat(parity_matrix(RepCode(3))[1:2,:], zeros(Bool,2,3))

"""
    hgp(h₁::AbstractMatrix{Bool}, h₂::AbstractMatrix{Bool})

Hypergraph product of two classical codes.
"""
function hgp(h₁,h₂)
    r₁, n₁ = size(h₁)
    r₂, n₂ = size(h₂)
    hx = hcat(kron(h₁, LinearAlgebra.I(n₂)), kron(LinearAlgebra.I(r₁), h₂'))
    hz = hcat(kron(LinearAlgebra.I(n₁), h₂), kron(h₁', LinearAlgebra.I(r₂)))
    hx, hz
end

"""
    $TYPEDEF

The Delfosse-Reichardt code is derived from the classical *self-orthogonal* Reed-Muller
codes. For parameters `(r,m)` = `(1,3)` and `(2,4)`, [delfosse2020short](@cite) constructs
families of:

- `[[8p, 6(p-1), 4]]` codes requiring `8` measurement rounds.
- `[[16p, 14p-8, 4]]` codes requiring `10` measurement rounds.

Delfosse and Reichardt ([delfosse2020short](@cite)) utilize the `[8, 4, 4]` Reed-Muller code
to construct `[[8p, 6(p−1), 4]]` self-dual CSS quantum codes for `p ≥ 2`, and the `[16, 11, 4]`
Reed-Muller code to construct `[[16p, 14p − 8, 4]]` self-dual CSS quantum codes for `p ≥ 1`.
The parameter `p` specifies the **number of blocks** in the code construction.

To generalize the code construction, we extended the approach by using self-orthogonal `Reed-Muller`
codes as base matrices for the `Delfosse-Reichardt` code.

!!! note
    Single-shot distance-3 fault tolerance uses two Reed-Muller subfamilies: *repetition* codes
    and *extended Hamming* codes. Their structure may enable `distance > 4` fault-tolerant sequences,
    raising a key *open problem* [delfosse2020short](@cite): "Find a minimum-length sequence of parity
    check measurements for distance-`7` fault-tolerant error correction with distance-`8` Reed-Muller codes."

# [[8p, 6(p−1), 4]] code family

An `[[16, 6, 4]]` Delfosse-Reichardt code of from `[[8p, 6(p−1), 4]]` code family
from [delfosse2020short](@cite).

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> p = 2; r = 1; m = 3;

julia> c = parity_checks(DelfosseReichardt(p, r, m))
+ XXXXXXXX________
+ ________XXXXXXXX
+ XXXX____XXXX____
+ XX__XX__XX__XX__
+ X_X_X_X_X_X_X_X_
+ ZZZZZZZZ________
+ ________ZZZZZZZZ
+ ZZZZ____ZZZZ____
+ ZZ__ZZ__ZZ__ZZ__
+ Z_Z_Z_Z_Z_Z_Z_Z_

julia> code_n(c), code_k(c)
(16, 6)
```

# [[16p, 14p − 8, 4]] code family

An `[[32, 20, 4]]` Delfosse-Reichardt code of from `[[16p, 14p − 8, 4]]` code family.

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> p = 2; r = 2; m = 4;

julia> c = parity_checks(DelfosseReichardt(p, r, m))
+ XXXXXXXXXXXXXXXX________________
+ ________________XXXXXXXXXXXXXXXX
+ XXXXXXXX________XXXXXXXX________
+ XXXX____XXXX____XXXX____XXXX____
+ XX__XX__XX__XX__XX__XX__XX__XX__
+ X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_
+ ZZZZZZZZZZZZZZZZ________________
+ ________________ZZZZZZZZZZZZZZZZ
+ ZZZZZZZZ________ZZZZZZZZ________
+ ZZZZ____ZZZZ____ZZZZ____ZZZZ____
+ ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__
+ Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_

julia> code_n(c), code_k(c)
(32, 20)
```

### Fields
    $TYPEDFIELDS


See also: [`DelfosseReichardtRep`](@ref), [`DelfosseReichardt823`](@ref)
"""
struct DelfosseReichardt <: AbstractCSSCode
    """The number of blocks in the Delfosse-Reichardt CSS code."""
    p::Int
    """The order of the classical Reed-Muller code."""
    r::Int
    """The log-length of the classical Reed-Muller code."""
    m::Int
    function DelfosseReichardt(p,r,m)
        p < 2 && throw(ArgumentError("The number of blocks must be at least 2 to construct a valid code."))
        if r < 0 || r > m
            throw(ArgumentError("Invalid parameters: r must be non-negative and r ≤ m in order to valid code."))
        end
        if !iszero(mod.(parity_matrix(ReedMuller(r,m))*parity_matrix(ReedMuller(r,m))',2))
            throw(ArgumentError("The `Reed-Muller` parity check matrix must be 'self-orthogonal' to construct a self-dual
            CSS `DelfosseReichardt` code. Use `search_self_orthogonal_rm_code` to search for good parameters for `Reed-Muller` codes
            that provide `self-orthogonal` seeds."))
        end
        new(p,r,m)
    end
end

"""
Search for parameters `(r,m)` of *self-orthogonal* `Reed-Muller` codes where the code `RM(r,m)`
satisfies ``H \\times H^\\top \\equiv 0 \\pmod{2}``. Skips the trivial case `RM(0,1)` which produces
a code with `k=0` logical qubits.

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; using QECCore: search_self_orthogonal_rm_code; # hide

julia> search_self_orthogonal_rm_code(6)
11-element Vector{Tuple{Int64, Int64}}:
 (1, 2)
 (1, 3)
 (2, 3)
 (2, 4)
 (3, 4)
 (2, 5)
 (3, 5)
 (4, 5)
 (3, 6)
 (4, 6)
 (5, 6)
```

Here is an example using a *self-orthogonal* classical `RM(3,5)` seed code
to demonstrate the generalization of the `Delfosse-Reichardt` construction.

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> p = 2; r = 3; m = 5;

julia> c = parity_checks(DelfosseReichardt(p, r, m))
+ XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX________________________________
+ ________________________________XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
+ XXXXXXXXXXXXXXXX________________XXXXXXXXXXXXXXXX________________
+ XXXXXXXX________XXXXXXXX________XXXXXXXX________XXXXXXXX________
+ XXXX____XXXX____XXXX____XXXX____XXXX____XXXX____XXXX____XXXX____
+ XX__XX__XX__XX__XX__XX__XX__XX__XX__XX__XX__XX__XX__XX__XX__XX__
+ X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_X_
+ ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ________________________________
+ ________________________________ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+ ZZZZZZZZZZZZZZZZ________________ZZZZZZZZZZZZZZZZ________________
+ ZZZZZZZZ________ZZZZZZZZ________ZZZZZZZZ________ZZZZZZZZ________
+ ZZZZ____ZZZZ____ZZZZ____ZZZZ____ZZZZ____ZZZZ____ZZZZ____ZZZZ____
+ ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__ZZ__
+ Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_Z_

julia> code_n(c), code_k(c)
(64, 50)
```

"""
function search_self_orthogonal_rm_code(maxₘ::Int)
    good_params = Tuple{Int, Int}[]
    for m in 1:maxₘ
        for r in 0:m
            # Skip RM(0,1) as it produces a trivial code (k=0)
            (r == 0 && m == 1) && continue
            try
                RM = ReedMuller(r, m)
                H = parity_matrix(RM)
                if all(iszero, mod.(H*H', 2))
                    push!(good_params, (r, m))
                end
            catch
                continue
            end
        end
    end
    return good_params
end

function _generalize_delfosse_reichardt_code(p::Int, r::Int, m::Int)
    # base matrix: Reed-Muller parity matrix
    H = parity_matrix(ReedMuller(r,m))
    r, c = size(H)
    new_c = p*c
    extended_H = zeros(Bool, r+p-1, new_c)
    # Create the first 'blocks' rows with 1s for the appropriate block
    for row in 1:p
        @inbounds @simd for block in 0:(p-1)
            start_c = block*c+1
            end_c = start_c+c-1
            if block == (row - 1)
                extended_H[row, start_c:end_c] .= 1
            end
        end
    end
    # Copy remaining rows directly to each block
    for row in (p+1):r+p-1
        @inbounds @simd for block in 0:(p-1)
            start_c = block*c+1
            end_c = start_c+c-1
            @views extended_H[row, start_c:end_c] .= H[row-p+1, :]
        end
    end
    return extended_H
end

function parity_matrix_xz(c::DelfosseReichardt)
    extended_mat = _generalize_delfosse_reichardt_code(c.p, c.r, c.m)
    return extended_mat, extended_mat
end

parity_matrix_x(c::DelfosseReichardt) = parity_matrix_xz(c)[1]

parity_matrix_z(c::DelfosseReichardt) = parity_matrix_xz(c)[2]

distance(c::DelfosseReichardt) = 4

@testitem "ECC Golay" begin
    using QECCore.LinearAlgebra
    using QECCore
    using QECCore: generator
    using Nemo: matrix, GF, echelon_form

    # Theorem: Let `C` be a binary linear code. If `C` is self-orthogonal and
    # has a generator matrix `G` where each row has weight divisible by four,
    # then every codeword of `C` has weight divisible by four. `H₂₄` is self-dual
    # because its generator matrix has all rows with weight divisible by four.
    # Thus, all codewords of `H₂₄` must have weights divisible by four. Refer to
    # pg. 30 to 33 of Ch1 of Fundamentals of Error Correcting Codes by Huffman,
    # Cary and Pless, Vera.
    function code_weight_property(matrix)
        for row in eachrow(matrix)
            count = sum(row)
            if count % 4 == 0
                return true
            end
        end
        return false
    end

    # Test the equivalence of punctured and extended code by verifying that puncturing
    # the binary parity check matrix H₂₄ in any coordinate and then extending it by adding
    # an overall parity check in the same position yields the original matrix H₂₄.
    # Steps:
    # 1) Puncture the Code: Remove the i-th column from H₂₄ to create a punctured matrix
    # H₂₃. Note: H₂₃ = H[:, [1:i-1; i+1:end]]
    # 2) Extend the Code: Add a column in the same position to ensure each row has even
    # parity. Note: H'₂₄ = [H₂₃[:, 1:i-1] c H₂₃[:, i:end]]. Here, c is a column vector
    # added to ensure each row in H'₂₄ has even parity.
    # 3) Equivalence Check: Verify that H'₂₄ = H₂₄.
    function puncture_code(mat, i)
        return mat[:, [1:i-1; i+1:end]]
    end

    function extend_code(mat, i)
        k, _ = size(mat)
        extended_mat = hcat(mat[:, 1:i-1], zeros(Bool, k, 1), mat[:, i:end])
        # Calculate the parity for each row
        for row in 1:k
            row_parity = sum(mat[row, :]) % 2 == 1
            extended_mat[row, i] = row_parity
        end
        return extended_mat
    end

    function minimum_distance(H)
        n = size(H, 2)
        min_dist = n + 1
        for x_bits in 1:(2^n - 1)
            x = reverse(digits(x_bits, base=2, pad=n))
            xᵀ = reshape(x, :, 1)
            if all(mod.(H * xᵀ, 2) .== 0)
                weight = sum(x)
                min_dist = min(min_dist, weight)
            end
        end
        return min_dist
    end

    @testset "Testing binary Golay codes properties" begin
        test_cases = [(24, 12), (23, 12)]
        for (n, k) in test_cases
            H = parity_matrix(Golay(n))
            mat = matrix(GF(2), parity_matrix(Golay(n)))
            computed_rank = rank(mat)
            @test computed_rank == n - k
        end

        # [24, 12, 8] binary Golay code is a self-dual code [huffman2010fundamentals](@cite).
        H = parity_matrix(Golay(24))
        @test code_weight_property(H) == true
        @test H[:, (12 + 1):end]  == H[:, (12 + 1):end]'
        # Example taken from [huffman2010fundamentals](@cite).
        @test parity_matrix(Golay(24)) == [0  1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0  0  0  0  0  0  0  0;
                                           1  1  1  0  1  1  1  0  0  0  1  0  0  1  0  0  0  0  0  0  0  0  0  0;
                                           1  1  0  1  1  1  0  0  0  1  0  1  0  0  1  0  0  0  0  0  0  0  0  0;
                                           1  0  1  1  1  0  0  0  1  0  1  1  0  0  0  1  0  0  0  0  0  0  0  0;
                                           1  1  1  1  0  0  0  1  0  1  1  0  0  0  0  0  1  0  0  0  0  0  0  0;
                                           1  1  1  0  0  0  1  0  1  1  0  1  0  0  0  0  0  1  0  0  0  0  0  0;
                                           1  1  0  0  0  1  0  1  1  0  1  1  0  0  0  0  0  0  1  0  0  0  0  0;
                                           1  0  0  0  1  0  1  1  0  1  1  1  0  0  0  0  0  0  0  1  0  0  0  0;
                                           1  0  0  1  0  1  1  0  1  1  1  0  0  0  0  0  0  0  0  0  1  0  0  0;
                                           1  0  1  0  1  1  0  1  1  1  0  0  0  0  0  0  0  0  0  0  0  1  0  0;
                                           1  1  0  1  1  0  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  1  0;
                                           1  0  1  1  0  1  1  1  0  0  0  1  0  0  0  0  0  0  0  0  0  0  0  1]

        # minimum distance test
        # [24, 12, 8]
        H = parity_matrix(Golay(24))
        @test minimum_distance(H) == 8
        # [23, 12, 7]
        H = parity_matrix(Golay(23))
        @test minimum_distance(H) == 7

        # cross-verifying the canonical equivalence of bordered reverse circulant matrix (A)
        # from [huffman2010fundamentals](@cite) with matrix A taken from [bhatia2018mceliece](@cite).
        A = [1 1 0 1 1 1 0 0 0 1 0 1;
             1 0 1 1 1 0 0 0 1 0 1 1;
             0 1 1 1 0 0 0 1 0 1 1 1;
             1 1 1 0 0 0 1 0 1 1 0 1;
             1 1 0 0 0 1 0 1 1 0 1 1;
             1 0 0 0 1 0 1 1 0 1 1 1;
             0 0 0 1 0 1 1 0 1 1 1 1;
             0 0 1 0 1 1 0 1 1 1 0 1;
             0 1 0 1 1 0 1 1 1 0 0 1;
             1 0 1 1 0 1 1 1 0 0 0 1;
             0 1 1 0 1 1 1 0 0 0 1 1;
             1 1 1 1 1 1 1 1 1 1 1 0]

        H = parity_matrix(Golay(24))
        @test echelon_form(matrix(GF(2), A)) == echelon_form(matrix(GF(2), H[1:12, 1:12]))
        # test self-duality for extended Golay code, G == H
        @test echelon_form(matrix(GF(2), generator(Golay(24)))) == echelon_form(matrix(GF(2), parity_matrix(Golay(24))))

        # All punctured and extended matrices are equivalent to the H₂₄. Test each column for puncturing and extending.
        for i in 1:24
            punctured_mat = puncture_code(H, i)
            extended_mat = extend_code(punctured_mat, i)
            @test extended_mat == H
        end
    end
end

@testitem "Generalized Delfosse-Reichardt code" begin

    using JuMP
    using HiGHS
    using QuantumClifford
    using QuantumClifford: stab_looks_good
    using QuantumClifford.ECC
    using Nemo: matrix, GF, echelon_form
    using QECCore
    using QECCore.LinearAlgebra
    using QECCore: _generalize_delfosse_reichardt_code, search_self_orthogonal_rm_code

    @testset "Testing Generalized Delfosse-Reichardt code properties" begin
        # from https://arxiv.org/pdf/2008.05051"
        code_families = [
            (2, 4),  # [[16p, 14p-8, 4]] code family
            (1, 3),  # [[8p, 6(p-1), 4]] code family
            (2, 5),  # not from paper, but arbitrary to demonstrate generalization
        ]
        for (r, m) in code_families
            @testset "DelfosseReichardt with RM(r=$r, m=$m) seed" begin
                for p in 2:4
                    c = DelfosseReichardt(p, r, m)
                    stab = parity_checks(c)
                    nₛ, kₛ = code_n(stab), code_k(stab)
                    H = stab_to_gf2(stab)
                    mat = matrix(GF(2), H)
                    computed_rank = rank(mat)
                    @test computed_rank == nₛ - kₛ
                    @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
                    @test stab_looks_good(stab, remove_redundant_rows=true)
                end
             end
        end

        max_m = 10
        parameters = search_self_orthogonal_rm_code(max_m)
        for (r, m) in parameters
            @testset "Delfosse-Reichardt code with RM(r=$r, m=$m) seed" begin
                for p in 2:4
                    code = DelfosseReichardt(p, r, m)
                    stab = parity_checks(code)
                    nₛ, kₛ = code_n(stab), code_k(stab)
                    H = stab_to_gf2(stab)
                    mat = matrix(GF(2), H)
                    computed_rank = rank(mat)
                    @test computed_rank == nₛ - kₛ
                    @test stab_looks_good(stab, remove_redundant_rows=true)
                end
            end
        end

        # crosscheck parity check matrices from VIII. 2 Generalizing the [8, 4, 4]
        # and [16, 11, 4] classical codes, pg. 11 of https://arxiv.org/pdf/2008.05051
        r = 1
        m = 3
        blocks = 2
        mat_paper = [1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0;
                     0 0 0 0 0 0 0 0 1 1 1 1 1 1 1 1;
                     0 0 0 0 1 1 1 1 0 0 0 0 1 1 1 1;
                     0 0 1 1 0 0 1 1 0 0 1 1 0 0 1 1;
                     0 1 0 1 0 1 0 1 0 1 0 1 0 1 0 1];
       @test echelon_form(matrix(GF(2), Matrix{Int}(_generalize_delfosse_reichardt_code(blocks,r,m)))) == echelon_form(matrix(GF(2), mat_paper))
    end
end

module QECCoreOscarExt

using QECCore
using DocStringExtensions

import Oscar
import Oscar: matrix, GF, hom, free_module, size, kernel, map, domain, gens

import QECCore: bivariate_bicycle_code_k

"""
For circulant *bivariate bicycle codes*, the parity-check matrices ``H_X`` and
``H_Z`` satisfy the rank equality ``\\text{rank}(H_X) = \\text{rank}(H_Z)``. This
follows from a symmetry in the code structure induced by a self-inverse permutation
matrix. We define ``C_\\ell`` as an `\\ell \\times \\ell`` permutation matrix such
that its `i`-th column has a `1` in row `j = -i \\mod \\ell``. Similarly, we define
``C_m`` for size ``m \\times m``, and let ``C = C_\\ell \\otimes C_m``. Using the
property that this matrix satisfies:

```math
\\begin{aligned}
C_\\ell S_\\ell C_\\ell = S_\\ell^T, \\quad C_m S_m C_m = S_m^T,
\\end{aligned}
```

it follows that the transposes of the circulant blocks are related by:

```math
\\begin{aligned}
A^T = C A C, \\quad B^T = C B C.
\\end{aligned}
```

Hence, the matrix ``H_Z`` can be expressed in terms of ``H_X`` as:

```math
\\begin{aligned}
H_Z = [B^T | A^T] = [C B C | C A C] = C [B | A] \\begin{bmatrix} 0 & C \\\\ C & 0 \\end{bmatrix} = C H_X \\begin{bmatrix} 0 & C \\\\ C & 0 \\end{bmatrix}.
\\end{aligned}
```

Since both left and right multiplications are with invertible matrices (`C` is
self-inverse and permutation), it follows that:

```math
\\begin{aligned}
\text{rank}(H_X) = \\text{rank}(H_Z)
\\end{aligned}
```

This yields a new expression for the number of encoded qubits:

```math
\\begin{aligned}
k = n - \\text{rank}(H_X) - \\text{rank}(H_Z) = n - 2 \\cdot \\text{rank}(H_Z).
\\end{aligned}
```

And further, using:

```math
\\begin{aligned}
\\ker(H_Z^T) = \\ker(A) \\cap \\ker(B),
\\end{aligned}
```

we get:

```math
\\begin{aligned}
k = 2 \\cdot \\dim(\\ker(A) \\cap \\ker(B)).
\\end{aligned}
```
"""
function QECCore.bivariate_bicycle_code_k(c::AbstractCSSCode)
    Hx = parity_matrix_x(c)
    n = size(Hx,2)÷2
    A = matrix(GF(2), Hx[:,1:n])
    B = matrix(GF(2), Hx[:,n+1:end])
    F = GF(2)
    hA = hom(free_module(F, size(A, 1)), free_module(F, size(A, 2)), A)
    hB = hom(free_module(F, size(B, 1)), free_module(F, size(B, 2)), B)
    ans = kernel(hA)[1] ∩ kernel(hB)[1]
    k = 2*size(map(domain(hA), gens(ans[1])), 1)
    return k
end

end # module

"""
    $TYPEDEF

The planar surface code refers to the code [kitaev2003fault](@cite) in a 2D lattice with open boundaries.
Illustration of a 3×2 surface code, where qubits are located on the edges:

```
|---1--(Z)--2---|---3---|
|  (X)  7       8       o
|---4---|---5---|---6---|
|       o       o       o
|       |       |       |
```

The surface code has open boundary conditions, unlike the toric code. To this end, we remove qubits (denoted by "o") and parity checks on the right and bottom sides.

Faces like `(1,4,7)` have `X` checks, and crosses like `(1,2,7)` have `Z` checks. Due to the removal of the bottom and right sides, we have some 3-qubit checks on the boundaries.

The parity checks of `Surface(3,2)` are:
```
X__X__X_
_X__X_XX
__X__X_X
ZZ____Z_
_ZZ____Z
___ZZ_Z_
____ZZ_Z
```

More information can be seen in [fowler2012surface](@cite).

### Fields
    $TYPEDFIELDS

"""
struct Surface <: AbstractCSSCode
    """The number of qubits in the `x` direction."""
    dx::Int
    """The number of qubits in the `z` direction."""
    dz::Int
end

code_n(c::Surface) = 2*c.dx*c.dz - c.dx -c.dz + 1

function parity_matrix_xz(c::Surface)
    tc = Toric(c.dx, c.dz)
    hx, hz = parity_matrix_xz(tc)
    n = code_n(tc)
    nchecks = c.dx*c.dz - 1
    # remove qubits on the right and bottom sides from the toric code
    removed_qubit_indices = vcat(
        c.dx*(c.dz+1):c.dx:c.dx*(2*c.dz-1), # right side
        c.dx*(2*c.dz-1)+1:2*c.dx*c.dz) # bottom side
    qubit_indices = setdiff(1:n, removed_qubit_indices)
    # also remove the checks on the right and bottom sides
    x_check_indices = setdiff(1:nchecks, nchecks-c.dx+2:nchecks)
    z_check_indices = setdiff(1:nchecks, c.dx:c.dx:nchecks)
    hx[x_check_indices,qubit_indices], hz[z_check_indices,qubit_indices]
end

parity_matrix_x(c::Surface) = parity_matrix_xz(c)[1]
parity_matrix_z(c::Surface) = parity_matrix_xz(c)[2]

distance(c::Surface) = min(c.dx, c.dz)

"""
    $TYPEDEF

The `[[n² + m²,(n - rank([C ∣ M]))² + (m − rank([C ∣ M]ᵀ))², d]]` **quantum
Tillich Zémor code** is a novel quantum LDPC code is constructed using the
hypergraph product of two classical seed **(n, m, r)-Structured LDPC** codes.

# Structured LDPC

The classical `(n, m, r)`-structured LDPC codes were introduced in [tillich2006minimum](@cite).
The minimum distance of structured binary LDPC codes with parity-check matrices of
the form ``[C \\mid M]``, where `C` is circulant and `M` has fixed column weight
``r \\geq 3``, is in ``O(n^{\\frac{r-2}{r-1} + \\epsilon})``, improving the previous
bound of ``O(n^{\\frac{r-1}{r}}``[arnault2025upperboundsminimumdistance](@cite).

The classical *structured* LDPC codes are defined by a specific structure in their
parity-check matrix `H`, which is composed of a circulant matrix `C` and a binary
matrix `M`. The ensemble of these codes is referred to as `(n, m, r)`-structured LDPC
codes, where `n` is the block length of the code, `m` is the number of parity-check
equations, `r` is the weight of the columns in the matrix `M`.

## Parity-Check Matrix Structure

The parity-check matrix `H` is an `m × n` binary matrix of the form: ``[C \\mid M]``
where: `C`  is an  ``m \\times m``  **circulant matrix**. `M` is an ``m \\times (n - m)``
binary matrix with specific properties.

### Circulant Matrix C

The circulant matrix `C` is defined as:

```math
\\begin{aligned}
C = \\begin{pmatrix}
1 &        &        &        & 1 \\\\
1 & 1      &        &        &   \\\\
  & 1      & \\ddots &        &   \\\\
  &        & \\ddots & 1      &   \\\\
  &        &        & 1      & 1
\\end{pmatrix}
\\end{aligned}
```

This matrix has the property that each row is a cyclic shift of the previous
row. The first row contains two consecutive `1`s, and the rest of the entries are `0`s.

### Binary Matrix M

The matrix `M` satisfies the following conditions:
- **No Zero Rows**: Every row of `M` contains at least one non-zero element.
- **Column Weight**: Every column of `M` has a constant weight `r`, where ``r \\geq 3``.

## Existence Conditions

The family of classical `(n, m, r)`-structured LDPC codes exists if and only if the
following conditions are satisfied:

```math
\\begin{aligned}
m \\geq r \\quad \\text{and} \\quad (n - m)r \\geq m
\\end{aligned}
```

These conditions ensure that the matrix `M` can be constructed with the required properties.

# Quantum ``(n, m, r)``-Structured LDPC codes

We introduce a novel construction of quantum LDPC codes from classical
``(n, m, r)``-structured LDPC seed codes, whose parity-check matrices
``H = [C \\mid M]`` consist of an ``m \\times m`` circulant core ``C`` with
column weight ``2`` (enabling linear-time encoding) and an ``m \\times (n-m)``
matrix `M` with column weight ``r \\geq 3`` and no zero rows. The resulting
**quantum Tillich-Zémor code** has block length ``N = n^2 + m^2` and code dimension
``K = (n - \\text{rank}([C \\mid M]))^2 + (m - \\text{rank}([C \\mid M]^\\top))^2``.
This construction inherits the classical seed code's sub-linear distance scaling
(``d = O(n^{\\frac{r-2}{r-1}+\\epsilon}``) per Theorem `1` of
[arnault2025upperboundsminimumdistance](@cite) while preserving efficient encoding.

# Examples

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; using QECCore;

julia> n, m, r = 4, 3, 3;

julia> c = parity_checks(TillichZemor(n, m, r))
+ X_______X___X___XX_______
+ _X_______X___X___XX______
+ __X_______X___X_X_X______
+ ___X_______X___XXXX______
+ X___X_______X______XX____
+ _X___X_______X______XX___
+ __X___X_______X____X_X___
+ ___X___X_______X___XXX___
+ ____X___X___X_________XX_
+ _____X___X___X_________XX
+ ______X___X___X_______X_X
+ _______X___X___X______XXX
+ Z_ZZ____________Z__Z_____
+ ZZ_Z_____________Z__Z____
+ _ZZZ______________Z__Z___
+ ____Z_ZZ___________Z__Z__
+ ____ZZ_Z____________Z__Z_
+ _____ZZZ_____________Z__Z
+ ________Z_ZZ____Z_____Z__
+ ________ZZ_Z_____Z_____Z_
+ _________ZZZ______Z_____Z
+ ____________Z_ZZZ__Z__Z__
+ ____________ZZ_Z_Z__Z__Z_
+ _____________ZZZ__Z__Z__Z

julia> code_n(c), code_k(c)
(25, 1)

julia> n, m, r = 100, 40, 40;

julia> c = TillichZemor(n, m, r);

julia> code_n(c), code_k(c)
(11600, 3722)
```

### Fields
    $TYPEDFIELDS
"""
struct TillichZemor{M} <: AbstractCSSCode where {M <: Union{Nothing,Tuple{AbstractMatrix,AbstractMatrix}}}
    """The block length of the classical **(n, m, r)-Structured LDPC** seed code."""
    n::Int
    """The number of check nodes (rows in the parity-check matrix `H`)."""
    m::Int
    """The column weight parameter for matrix `M` (each column of M must have exactly `r` ones)."""
    r::Int
    """The `X`-type and `Z`-type parity check matrices generated via the hypergraph product of the classical
    parity check matrix `H = [C | M]`. For randomized constructions via `random_TillichZemor_code`, these
    matrices are derived from the hypergraph product of a randomly generated **(n, m, r)-Structured LDPC**
    seed code."""
    matrices::M

    function TillichZemor(n::Int, m::Int, r::Int, matrices::M=nothing) where {M <: Union{Nothing,Tuple{AbstractMatrix,AbstractMatrix}}}
        (m ≥ r && (n - m)*r ≥ m) || throw(ArgumentError(("Conditions for the existence of `M` in `H = [C | M]` are not satisfied.")))
        new{M}(n, m, r, matrices)
    end
end

"""Function to create a circulant matrix C of size m x m"""
function _create_circulant_matrix(m::Int)
    first_row = zeros(Int, m)
    first_row[1] = 1
    first_row[end] = 1
    C = zeros(Int, m, m)
    for i in 1:m
        C[i, :] = circshift(first_row, i-1)
    end
    return C
end

"""create the matrix M of size m x (n - m) with column weight r."""
function _create_matrix_M_deterministic(m::Int, n::Int, r::Int)
    M = zeros(Int, m, n - m)
    # Fill M such that each column has exactly r ones
    for col in 1:(n - m)
        # Deterministically select r distinct rows to place ones
        rows = mod1.((col-1)*r+1:col*r, m)
        M[rows, col] .= 1
    end
    # Ensure no row is all zeros
    for row in 1:m
        if all(M[row, :] .== 0)
            # Deterministically select the first column to set this row to 1
            M[row, 1] = 1
        end
    end
    return M
end

function parity_matrix_xz(c::TillichZemor{Nothing})::Tuple{AbstractMatrix,AbstractMatrix}
    C = _create_circulant_matrix(c.m)
    M = _create_matrix_M_deterministic(c.m, c.n, c.r)
    # The parity-check matrix H = [C | M]
    H = hcat(C, M)
    hx, hz = hgp(H,H)
    return hx, hz
end

function _create_matrix_M_random(rng::AbstractRNG, m::Int, n::Int, r::Int)
    M = zeros(Int, m, n - m)
    for col in 1:(n - m)
        # Randomly select r distinct rows to place ones
        rows = randperm(rng, m)[1:r]
        M[rows, col] .= 1
    end
    # Ensure no row is all zeros
    for row in 1:m
        if all(M[row, :] .== 0)
            # Randomly select a column and set this row to 1
            col = rand(rng, 1:(n - m))
            M[row, col] = 1
        end
    end
    return M
end

function _construct_parity_check_matrix(rng::AbstractRNG, n::Int, m::Int, r::Int)
    (m ≥ r && (n - m)*r ≥ m) || throw(ArgumentError(("Conditions for the existence of `M` in `H = [C | M]` are not satisfied.")))
    C = _create_circulant_matrix(m)
    M = _create_matrix_M_random(rng, m, n, r)
    # The parity-check matrix H = [C | M]
    H = hcat(C, M)
    return H
end

"""
The **random Tillich Zémor code** is a quantum LDPC code constructed using the
hypergraph product of two randomized classical **(n, m, r)-Structured LDPC** seed codes.

The parity-check matrix ``H = [C \\mid M]`` is generated by combining a deterministic
circulant core ``C`` of size ``m \\times m`` with column weight ``2`` and a randomized
matrix ``M`` of size ``m \\times (n-m)``. Each column of ``M`` contains exactly ``r \\geq 3``
nonzero entries, which are placed uniformly at random while ensuring that no row of M is
entirely zero. This construction ensures a structured yet partially randomized design for
the seed parity-check matrix ``H = [C \\mid M]``.

This particular implementation is bespoke to QuantumClifford.jl -- there might be
other implementations of randomly sampling Tillich Zémor codes.
"""
function random_TillichZemor_code(rng::AbstractRNG, n::Int, m::Int, r::Int)
    H = _construct_parity_check_matrix(rng, n, m, r)
    hx, hz = hgp(H, H)
    TillichZemor(n, m, r, (hx, hz))
end
random_TillichZemor_code(n::Int, m::Int, r::Int) = random_TillichZemor_code(GLOBAL_RNG, n, m, r)

function parity_matrix_xz(c::TillichZemor{<:Tuple})::Tuple{AbstractMatrix,AbstractMatrix}
    return c.matrices
end

parity_matrix_x(c::TillichZemor) = parity_matrix_xz(c)[1]

parity_matrix_z(c::TillichZemor) = parity_matrix_xz(c)[2]

code_n(c::TillichZemor) = c.n^2 + c.m^2

@testitem "Gallager LDPC code" begin
    using LinearAlgebra
    using QECCore
    using QECCore: generator
    using Random
    using SparseArrays
    using Nemo: matrix, GF, echelon_form

    @testset "Gallager LDPC" begin
        for μ in 2:10
            for wc in 3:10
                for wr in [wc+1, wc+3, 2*wc]
                    wr <= wc && continue
                    @testset "μ=$μ, wc=$wc, wr=$wr" begin
                        rng1 = MersenneTwister(123)
                        rng2 = MersenneTwister(123)
                        H = random_Gallager_ldpc(rng1, μ, wc, wr)
                        H1 = random_Gallager_ldpc(rng2, μ, wc, wr)
                        @test Matrix(H) == Matrix(H1)
                        m, n = size(H)
                        @test m == μ*wc
                        @test n == μ*wr
                        @test all(sum(H, dims=1) .== wc)
                        @test all(sum(H, dims=2) .== wr)
                        H1 = H[1:μ, :]
                        for d in 2:wc
                            block = H[(d-1)*μ+1:d*μ, :]
                            for row in 1:μ
                                @test sort(block[row, :]) == sort(H1[row, :])
                            end
                        end
                        r = rank(matrix(GF(2), H))
                        @test r ≤ m && 0 < 1 - r/n < 1
                    end
                    @testset "μ=$μ, wc=$wc, wr=$wr" begin
                        rng1 = MersenneTwister(1)
                        rng2 = MersenneTwister(2)
                        H = random_Gallager_ldpc(rng1, μ, wc, wr)
                        H1 = random_Gallager_ldpc(rng2, μ, wc, wr)
                        @test Matrix(H) != Matrix(H1)
                        m, n = size(H)
                        @test m == μ*wc
                        @test n == μ*wr
                        @test all(sum(H, dims=1) .== wc)
                        @test all(sum(H, dims=2) .== wr)
                        H1 = H[1:μ, :]
                        for d in 2:wc
                            block = H[(d-1)*μ+1:d*μ, :]
                            for row in 1:μ
                                @test sort(block[row, :]) == sort(H1[row, :])
                            end
                        end
                        r = rank(matrix(GF(2), H))
                        @test r ≤ m && 0 < 1 - r/n < 1
                    end
                end
            end
        end
    end
end

@testitem "Quantum Reed-Muller" begin
    using Test
    using Nemo: rref, matrix, GF
    using QECCore.LinearAlgebra
    using QECCore

    function designed_distance(mat)
        dist = 3
        for row in eachrow(mat)
            count = sum(row)
            if count < dist
                return false
            end
        end
        return true
    end

    @testset "Test QuantumReedMuller(r,m) properties" begin
        for m in 3:10
            H = parity_matrix(QuantumReedMuller(m))
            @test designed_distance(H) == true
            @test code_n(QuantumReedMuller(m)) == 2^m - 1
            @test code_k(QuantumReedMuller(m)) == 1
            @test distance(QuantumReedMuller(m)) == 3
            @test H == parity_matrix(CSS(parity_matrix_x(QuantumReedMuller(m)), parity_matrix_z(QuantumReedMuller(m))))
        end
    end


    @testset "QuantumReedMuller equivalence to simple codes" begin
        # QuantumReedMuller(3) is the Steane7 code.
        @test rref(matrix(GF(2),parity_matrix(Steane7()))) == rref(matrix(GF(2),parity_matrix(QuantumReedMuller(3))))
        
        # [[15,1,3]] qrm code from table 1 of https://arxiv.org/pdf/1705.0010
        pm = [ 1  0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0;
        0  1  1  0  0  1  1  0  0  1  1  0  0  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0;
        0  0  0  1  1  1  1  0  0  0  0  1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0;
        0  0  0  0  0  0  0  1  1  1  1  1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  0  0  1  0  0  0  1  0  0  0  1  0  0;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  0  0  1  0  0  0  1  0  0  0  1  0;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  0  0  1  0  0  0  1  0  0  0  1;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0  1  1  1  1;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  1  0  0  0  0  0  1  0  1;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  0  0  0  0  0  0  1  1;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1  1  1  1  1;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  0  1  0  1  0  1;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  0  0  1  1;
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1]
        @test rref(matrix(GF(2),parity_matrix(QuantumReedMuller(4)))) == rref(matrix(GF(2),pm))
    end
end

@testitem "Gottesman codes should correct all single-qubit errors" begin
    using QECCore
    using Test
    import QuantumClifford: single_x, single_y, single_z, comm, nqubits
    import QuantumClifford.ECC: parity_checks

    @testset "Gottesman codes should correct all single-qubit errors" begin
        for j in 3:12
            H = parity_checks(Gottesman(j))
            syndromes = Set([]) # the set automatically removes repeated entries
            for error_type in (single_x, single_y, single_z)
                for bit_index in 1:nqubits(H)
                    syndrome = comm(H, error_type(nqubits(H), bit_index))
                    @test any(==(0x1), syndrome) # checking the syndrome is not trivially zero
                    push!(syndromes, syndrome)
                end
            end
            @test length(syndromes) == 3*nqubits(H)
        end
    end
end

@testitem "ECC Goppa" begin
    using Random
    using QECCore
    using LinearAlgebra
    import Nemo
    using Nemo: finite_field, GF, polynomial_ring, evaluate, FqFieldElem, degree, is_irreducible, gcd, derivative, matrix, inv, is_monic, echelon_form, transpose, nullspace, iszero
    using QuantumClifford
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractECC
    using Random: MersenneTwister, GLOBAL_RNG, AbstractRNG, rand
    using QECCore: random_Goppa_code

    @testset "Testing Goppa codes properties" begin
        rng = MersenneTwister(123)
        for m in 3:12
            for t in 2:m-1
                ga = random_Goppa_code(rng, m, t)
                gx = ga.g
                # Goppa generator polynomial, `g(x)` is an irreducible polynomial.
                @test is_irreducible(gx) && is_monic(gx)
                # The Goppa polynomial, `g(x)`, is square free, thus no repeated roots, if the gcd with the derivative is 1.
                @test gcd(derivative(gx), gx) == 1
                mat = matrix(GF(2), parity_matrix(ga))
                @test size(mat, 1) <= size(mat, 2)
                computed_rank = rank(mat)
                # For parity check matrix matrix `H = XY` over `GF(2ᵐ)`, maximum of `m * t` rows are linearly independent, hence `Rank(XY) ≤ m * t`[singh2019code](@cite).
                @test computed_rank <= m * t
                n = length(ga.L)
                @test  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) >= n - m*t
                @test degree(ga.g) ≤ length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) # degenerate cases included.
            end
        end
    end

    # [12, 4, ≥ 5]
    m = 4
    t = 2
    F, α = finite_field(2, m, :α)
    R, x = polynomial_ring(F, :x)
    g = x^2 + x + α^3
    L = [α^i for i in 2:13]
    ga = Goppa(m, t, g, L)
    n = length(L)
    k = n - m*t
    d = 2t + 1
    H = parity_matrix(ga)
    @test  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) >= n - m*t
    # From https://surface.syr.edu/cgi/viewcontent.cgi?article=1846&context=honors_capstone
    ref_mat = [0 0 1 0 1 0 0 0 0 0 0 1;
               0 1 1 1 0 0 0 0 1 0 0 0;
               0 0 0 0 1 1 0 1 0 1 1 1;
               1 1 0 0 0 1 1 1 0 0 0 0;
               1 1 1 1 0 0 1 0 1 1 1 1;
               0 0 1 0 0 0 0 0 1 1 1 0;
               0 1 0 0 0 0 0 1 0 1 0 1;
               0 1 1 1 1 0 1 1 1 0 0 1];
    @test echelon_form(matrix(GF(2), H)) == echelon_form(matrix(GF(2), ref_mat))
    @test gcd(derivative(ga.g), ga.g) == 1
    mat = matrix(GF(2), parity_matrix(ga))
    computed_rank = rank(mat)
    @test computed_rank <= m * t
    n = length(ga.L)
    @test  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) >= n - m*t

    # From https://doc.sagemath.org/html/en/reference/coding/sage/coding/goppa_code.html
    # [55, 16, d]
    m = 6
    F, α = finite_field(2, m, :α)
    R, x = polynomial_ring(F, :x)
    t = 9
    g = x^t + 1
    ga = Goppa(m, t, g)
    @test length(ga.L) == 55 &&  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) == 16
    @test gcd(derivative(ga.g), ga.g) == 1
    mat = matrix(GF(2), parity_matrix(ga))
    computed_rank = rank(mat)
    @test computed_rank <= m * t
    n = length(ga.L)
    @test  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) >= n - m*t
    # [8, 2, d]
    m = 3
    F, α = finite_field(2, m, :α)
    R, x = polynomial_ring(F, :x)
    t = 2
    g = x^t + x + 1
    ga = Goppa(m, t, g)
    @test length(ga.L) == 8 &&  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) == 2
    @test gcd(derivative(ga.g), ga.g) == 1
    mat = matrix(GF(2), parity_matrix(ga))
    computed_rank = rank(mat)
    @test computed_rank <= m * t
    n = length(ga.L)
    @test  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) >= n - m*t

    # From example 1.9 of https://arxiv.org/pdf/1907.12754
    m = 4
    t = 2
    F, α = finite_field(2, m, :α)
    R, z = polynomial_ring(F, :z)
    g = z^2 + α^7*z + 1
    L = [α^i for i in 2:13]
    ga = Goppa(m, t, g, L)
    n = length(L)
    k = n - m*t
    d = 2t + 1
    H = parity_matrix(ga)
    @test  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) >= n - m*t
    mat = matrix(GF(2), parity_matrix(ga))
    computed_rank = rank(mat)
    @test computed_rank <= m * t
    ref_mat = [0 1 0 1 0 0 1 1 0 1 1 0;
               1 1 1 0 0 0 1 0 0 1 0 0;
               0 1 0 0 1 0 1 1 1 0 0 1;
               1 0 1 1 1 0 0 0 0 1 1 1;
               1 0 0 0 0 1 1 1 0 1 1 0;
               1 0 0 1 1 0 0 0 1 0 1 1;
               1 1 1 0 1 0 0 1 1 0 1 0;
               1 1 1 0 1 0 1 0 1 1 1 0]
    @test echelon_form(matrix(GF(2), H)) == echelon_form(matrix(GF(2), ref_mat))
    ref_G = [1 1 1 1 0 1 0 1 0 1 0 0;
             0 1 0 0 1 1 1 1 0 0 1 0;
             0 0 1 0 1 0 1 1 1 0 0 0;
             0 1 0 1 0 0 1 1 0 0 0 1];
    G = transpose(nullspace(mat)[2])
    @test iszero(G*transpose(mat))
    @test echelon_form(G) == echelon_form(matrix(GF(2), ref_G))

    # From https://crypto-kantiana.com/elena.kirshanova/talks/Talk_McEliece.pdf
    t = 2
    m = 3
    F, α = finite_field(2, m, :α)
    R, x = polynomial_ring(F, :x)
    g = x^t + x + 1
    L = [F(0), F(1), α, α^2, α + 1, α^2 + α, α^2 + α + 1, α^2 + 1]
    ga = Goppa(m, t, g, L)
    H = parity_matrix(ga)
    ref_H = [1 1 0 0 0 0 0 0;
             0 0 0 1 0 1 1 1;
             0 0 1 1 1 0 0 1;
             0 1 1 1 1 1 1 1;
             0 0 1 0 1 1 0 1;
             0 0 0 1 1 1 1 0];
    mat = matrix(GF(2), parity_matrix(ga))
    computed_rank = rank(mat)
    @test computed_rank <= m * t
    n = length(ga.L)
    @test  length(ga.L) - rank(matrix(GF(2), parity_matrix(ga))) >= n - m*t
    @test echelon_form(matrix(GF(2), H)) == echelon_form(matrix(GF(2), ref_H))
end

"""
    $TYPEDEF

An arbitrary CSS error correction code defined by its `X` and `Z` checks.

### Fields
    $TYPEDFIELDS
"""
struct CSS <: AbstractCSSCode
    """The parity check matrix of the `X` stabilizers."""
    Hx::Matrix{Bool}
    """The parity check matrix of the `Z` stabilizers."""
    Hz::Matrix{Bool}
    function CSS(Hx, Hz)
        n = size(Hx, 2)
        if n != size(Hz, 2) error("When constructing a CSS quantum code, the two classical codes are required to have the same block size") end
        #if size(Hx,1)+size(Hz,1) >= n error("When constructing a CSS quantum code, the total number of checks (rows) in the parity checks of the two classical codes have to be lower than the block size (the number of columns).") end
        check_allrowscommute(Hx, Hz) || error("The CSS code just created is invalid -- its rows do not commute. This is either a bug in this library, or an inconsistent parity check matrices were provided to the CSS constructor.")
        new(Hx, Hz)
    end
end

function check_allrowscommute(Hx, Hz)
    for rowx in eachrow(Hx)
        for rowz in eachrow(Hz)
            comm = sum(rowx .& rowz)
            isodd(comm) && return false
        end
    end
    return true
end

function parity_matrix(c::CSS)
    extended_Hx = Matrix{Bool}(vcat(c.Hx, zeros(size(c.Hz))))
    extended_Hz = Matrix{Bool}(vcat(zeros(size(c.Hx)), c.Hz))
    return hcat(extended_Hx, extended_Hz)
end

parity_matrix_x(c::CSS) = c.Hx
parity_matrix_z(c::CSS) = c.Hz

code_n(c::CSS) = size(c.Hx,2)
code_s(c::CSS) = size(c.Hx, 1) + size(c.Hz, 1)


# Parity matrix for general CSS codes
parity_matrix(c::AbstractCSSCode) = parity_matrix(CSS(parity_matrix_x(c), parity_matrix_z(c)))

"""
    $TYPEDEF

The family of Reed-Muller codes, as discovered by Muller in his 1954 paper [muller1954application](@cite) and Reed who proposed the first efficient decoding algorithm [reed1954class](@cite).

Let `m` be a positive integer and `r` a nonnegative integer with `r ≤ m`. These linear codes, denoted as `RM(r, m)`, have order `r` (where `0 ≤ r ≤ m`) and codeword length `n` of `2ᵐ`.

Two special cases of generator(RM(r, m)) exist:
    1. `generator(RM(0, m))`: This is the `0ᵗʰ`-order `RM` code, similar to the binary repetition code with length `2ᵐ`. It's characterized by a single basis vector containing all ones.
    2. `generator(RM(m, m))`: This is the `mᵗʰ`-order `RM` code. It encompasses the entire field `F(2ᵐ)`, representing all possible binary strings of length `2ᵐ`.

You might be interested in consulting [raaphorst2003reed](@cite), [abbe2020reed](@cite), and [djordjevic2021quantum](@cite) as well.

The dimension of `RM(m - r - 1, m)` equals the dimension of the dual of `RM(r, m)`. Thus, `RM(m - r - 1, m) = RM(r, m)^⊥` shows that the [dual code](https://en.wikipedia.org/wiki/Dual_code) of `RM(r, m)` is `RM(m − r − 1, m)`, indicating the parity check matrix of `RM(r, m)` is the generator matrix for `RM(m - r - 1, m)`.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/reed_muller).

See also: [`RecursiveReedMuller`](@ref) and [`QuantumReedMuller`](@ref)

### Fields
    $TYPEDFIELDS
"""
struct ReedMuller <: AbstractCECC
    """The order of the code."""
    r::Int
    """The log-length of the code."""
    m::Int

    function ReedMuller(r, m)
        if r < 0 || r > m
            throw(ArgumentError("Invalid parameters: r must be non-negative and r ≤ m in order to valid code."))
        end
        new(r, m)
    end
end

function _variablesₓᵢ_rm(m, i)
    return repeat([fill(1, 2 ^ (m - i - 1)); fill(0, 2 ^ (m - i - 1))], outer = 2 ^ i)
end

function _vmult_rm(vecs...)
    return [reduce(*, a, init=1) for a in zip(vecs...)]
end

function generator(c::ReedMuller)
    r = c.r
    m = c.m
    xᵢ = [_variablesₓᵢ_rm(m, i) for i in 0:m - 1]
    row_matrices = [reduce(_vmult_rm, [xᵢ[i + 1] for i in S], init = ones(Int, 2 ^ m)) for s in 0:r for S in combinations(0:m - 1, s)]
    rows = length(row_matrices)
    cols = length(row_matrices[1])
    G = reshape(vcat(row_matrices...), cols, rows)'
    G = Matrix{Bool}(G)
    return G 
end

function parity_matrix(c::ReedMuller)
    H = generator(ReedMuller(c.m - c.r - 1, c.m))
    return H
end

code_n(c::ReedMuller) = 2 ^ c.m

code_k(c::ReedMuller) = sum(binomial.(c.m, 0:c.r))

distance(c::ReedMuller) = 2 ^ (c.m - c.r)

rate(c::ReedMuller) = code_k(c::ReedMuller) / code_n(c::ReedMuller)

@testitem "Perfect5" begin
    using Test
    using QECCore

    @testset "Perfect5" begin
        p5 = Perfect5()
        @test parity_matrix(p5) == Bool[1 0 0 1 0 0 1 1 0 0;
                                            0 1 0 0 1 0 0 1 1 0;
                                            1 0 1 0 0 0 0 0 1 1;
                                            0 1 0 1 0 1 0 0 0 1]
        @test code_n(p5) == 5
        @test code_s(p5) == 4
        @test distance(p5) == 3
    end
end

"""
    $TYPEDEF

The family of `[[2ʲ, 2ʲ - j - 2, 3]]` Gottesman codes, also known as quantum Hamming codes, as described in [Gottesman's 1997 PhD thesis](@cite gottesman1997stabilizer) and in [gottesman1996class](@cite).

You might be interested in consulting [yu2013all](@cite) and [chao2018quantum](@cite) as well.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/quantum_hamming)

### Fields
    $TYPEDFIELDS
"""
struct Gottesman <: AbstractQECC
    """The parameter `j` of the code."""
    j::Int

    function Gottesman(j)
        (j >= 3 && j < 21) || error("In `Gottesman(j)`, `j` must be ≥  3 in order to obtain a valid code and < 21 to remain tractable")
        new(j)
    end
end

code_n(c::Gottesman) = 2^c.j

function parity_matrix(c::Gottesman)
    j = c.j
    s = j+2
    n = 2^j

    H = zeros(Bool, s, 2*n)
    for i in 1:n
        H[1, i] = true
        H[2, i+n] = true
    end
    for i in 0:n-1 # column of H, corresponds to a single qubit error that is detectable)
        Xⁱ = i
        Zⁱ = i÷2
        jeven = j%2 == 0
        ieven = i%2 == 0
        if (jeven && ieven) || (!jeven && ieven && i < n÷2) || (!jeven && !ieven && i ≥ n÷2)
            Zⁱ = ~Zⁱ
        end
        for b in 0:j-1 # which check to consider (row of H), also which bit to extract
            H[s-b,i+1] = isone((Zⁱ>>b)&0x1)
            H[s-b,i+n+1] = isone((Xⁱ>>b)&0x1)
        end
    end
    H
end

@testitem "ECC BCH" begin
    using LinearAlgebra
    using Nemo: matrix, finite_field, GF, minpoly, degree, defining_polynomial, is_irreducible
    using QECCore: BCH, code_k, generator_polynomial, parity_matrix

    # To prove that t-bit error correcting BCH code indeed has minimum distance
    # of at least 2 * t + 1, it is shown that no 2 * t or fewer columns of its
    # binary parity check matrix H sum to zero. A formal mathematical proof can
    # be found on pages 168 and 169 of Ch6 of Error Control Coding by Lin, Shu
    # and Costello, Daniel. The parameter 2 * t + 1 is usually called the designed
    # distance of the t-bit error correcting BCH code.

    function check_designed_distance(matrix, t)
        n_cols = size(matrix, 2)
        for num_cols in 1:2 * t
            for i in 1:n_cols - num_cols + 1
                combo = matrix[:, i:(i + num_cols - 1)]
                sum_cols = sum(combo, dims = 2)
                if all(sum_cols .== 0)
                    return false  # Minimum distance is not greater than `2 * t`.
                end
            end
        end
        return true  # Minimum distance is at least `2 * t + 1`.
    end

    @testset "Testing properties of BCH codes" begin
        m_cases = [3, 4, 5, 6, 7, 8, 9, 10]
        for m in m_cases
            n = 2 ^ m - 1
            lower_bound = round(Int, (2^m - 1) / m)
            @test lower_bound < n
            for t in [1,2]
                H = parity_matrix(BCH(m, t))
                @test check_designed_distance(H, t) == true
                # n - k == degree of generator polynomial, `g(x)` == rank of binary parity check matrix, `H`.
                mat = matrix(GF(2), parity_matrix(BCH(m, t)))
                computed_rank = rank(mat)
                @test computed_rank == degree(generator_polynomial(BCH(m, t)))
                @test code_k(BCH(m, t)) == n - degree(generator_polynomial(BCH(m, t)))
                # BCH code is cyclic as its generator polynomial, `g(x)` divides `xⁿ - 1`, so `mod (xⁿ - 1, g(x))` = 0.
                gx = generator_polynomial(BCH(m, t))
                GF2x, x = GF(2)["x"]
                @test mod(x ^ n - 1, gx) == 0
            end
        end

        #example taken from Ch6 of Error Control Coding by Lin, Shu and Costello, Daniel
        @test parity_matrix(BCH(4, 2))  ==    [1  0  0  0  1  0  0  1  1  0  1  0  1  1  1;
                                               0  1  0  0  1  1  0  1  0  1  1  1  1  0  0;
                                               0  0  1  0  0  1  1  0  1  0  1  1  1  1  0;
                                               0  0  0  1  0  0  1  1  0  1  0  1  1  1  1;
                                               1  0  0  0  1  1  0  0  0  1  1  0  0  0  1;
                                               0  0  0  1  1  0  0  0  1  1  0  0  0  1  1;
                                               0  0  1  0  1  0  0  1  0  1  0  0  1  0  1;
                                               0  1  1  1  1  0  1  1  1  1  0  1  1  1  1]

        # Examples taken from https://web.ntpu.edu.tw/~yshan/BCH_code.pdf.
        GF2x, x = GF(2)["x"]
        GF2⁴, a = finite_field(2, 4, "a")
        GF2⁶, b = finite_field(2, 6, "b")
        @test defining_polynomial(GF2x, GF2⁴) ==  x ^ 4 + x + 1
        @test is_irreducible(defining_polynomial(GF2x, GF2⁴)) == true
        @test generator_polynomial(BCH(4, 2)) == x ^ 8 + x ^ 7 +  x ^ 6 +  x ^ 4 + 1
        @test generator_polynomial(BCH(4, 3)) == x ^ 10 + x ^ 8 +  x ^ 5 +  x ^ 4 +  x ^ 2 + x + 1

        # Nemo.jl uses [Conway polynomial](https://en.wikipedia.org/wiki/Conway_polynomial_(finite_fields)),
        # a standard way to represent the primitive polynomial for finite Galois fields GF(pᵐ) of degree m,
        # where p is a prime number. The GF(2⁶)'s Conway polynomial is p(z) = z⁶ + z⁴ + z³ + z + 1. In contrast,
        # the polynomial given in https://web.ntpu.edu.tw/~yshan/BCH_code.pdf is p(z) = z⁶ + z + 1. Because both
        # polynomials are irreducible, they are also primitive polynomials for `GF(2⁶)`.
    
        test_cases = [(6, 1), (6, 2), (6, 3), (6, 4), (6, 5), (6, 6), (6, 7)]
        @test defining_polynomial(GF2x, GF2⁶) == x ^ 6 + x ^ 4 + x ^ 3 + x + 1
        @test is_irreducible(defining_polynomial(GF2x, GF2⁶)) == true
        for i in 1:length(test_cases)
            m, t = test_cases[i]
            if t == 1
                @test generator_polynomial(BCH(m, t)) == defining_polynomial(GF2x, GF2⁶)
            else
                prev_t = test_cases[i - 1][2]
                @test generator_polynomial(BCH(m, t)) == generator_polynomial(BCH(m, prev_t)) * minpoly(GF2x, b ^ (t + prev_t - (t - prev_t - 1)))
            end
        end

        results = [57 51 45 39 36 30 24]
        for (result, (m, t)) in zip(results, test_cases)
            @test code_k(BCH(m, t)) == result
            @test check_designed_distance(parity_matrix(BCH(m, t)), t) == true
        end

        # Reproduce some results from Table, page 8-9 of https://web.ntpu.edu.tw/~yshan/BCH_code.pdf.
        n = 7
        @test code_k(BCH(Int(log2(n + 1)), 1)) == 4
        n = 15
        k_values = [11, 7, 5]
        t_values = collect(1:3)
        for (t, expected_k) in zip(t_values, k_values)
            @test code_k(BCH(Int(log2(n + 1)), t)) == expected_k
        end
        n = 31
        k_values = [26, 21, 16, 11]
        t_values = collect(1:3)
        push!(t_values, 5)
        for (t, expected_k) in zip(t_values, k_values)
            @test code_k(BCH(Int(log2(n + 1)), t)) == expected_k
        end
        n = 63
        k_values = collect(57:-6:39)
        push!(k_values, 36)
        push!(k_values, 30)
        push!(k_values, 24)
        t_values = collect(1:7)
        for (t, expected_k) in zip(t_values, k_values)
            @test code_k(BCH(Int(log2(n + 1)), t)) == expected_k
        end
        n = 127
        k_values = collect(120:-7:36)
        t_values = collect(1:7)
        push!(t_values, 9)
        push!(t_values, 10)
        push!(t_values, 11)
        push!(t_values, 13)
        push!(t_values, 14)
        for (t, expected_k) in zip(t_values, k_values)
            @test code_k(BCH(Int(log2(n + 1)), t)) == expected_k
        end
        n = 1023
        k_values = collect(1013:-10:863)
        push!(k_values, 858)
        t_values = collect(1:17)
        for (t, expected_k) in zip(t_values, k_values)
            @test code_k(BCH(Int(log2(n + 1)), t)) == expected_k
        end
    end
end

abstract type ColorCode <: AbstractCSSCode end

"""Planar color codes that encode a single logical qubit."""
abstract type TriangularCode <: ColorCode end

"""
    $TYPEDEF

Triangular code following the `4.8.8` tiling. Constructor take a distance `d` as input.

### Example

Here is `[[17,1, 5]]` color code following the `4.8.8` tiling:

```jldoctest
julia> import HiGHS; import JuMP; # hide

julia> using QuantumClifford.ECC: Triangular666, DistanceMIPAlgorithm; # hide

julia> c = Triangular488(5);

julia> code = Stabilizer(c)
+ XXXX_____________
+ X_X_XX___________
+ __XX_XX__XX__XX__
+ ____XX__XX_______
+ ______XX__XX_____
+ _______X___X___XX
+ ________XX__XX___
+ __________XX__XX_
+ ZZZZ_____________
+ Z_Z_ZZ___________
+ __ZZ_ZZ__ZZ__ZZ__
+ ____ZZ__ZZ_______
+ ______ZZ__ZZ_____
+ _______Z___Z___ZZ
+ ________ZZ__ZZ___
+ __________ZZ__ZZ_

julia> distance(c, DistanceMIPAlgorithm(solver=HiGHS))
5
```

More information can be seen in [landahl2011color](@cite)

### Fields
    $TYPEDFIELDS
"""
struct Triangular488 <: TriangularCode
    """The distance of the code."""
    d::Int

    function Triangular488(d)
        if d%2!=1
            throw(ArgumentError("Only odd distance triangular color codes are allowed.\nRefer to https://arxiv.org/abs/1108.5738"))
        elseif d<3
            throw(ArgumentError("Smallest allowed distance is 3.\nRefer to https://arxiv.org/abs/1108.5738"))
        end
        return new(d)
    end
end

"""
    $TYPEDEF

Triangular code following the `6.6.6` tiling. Constructor take a distance `d` as input.

### Example

Here is `[[19,1, 5]]` color code following the `6.6.6` tiling:

```jldoctest
julia> import HiGHS; import JuMP; # hide

julia> using QuantumClifford.ECC: Triangular666, DistanceMIPAlgorithm; # hide

julia> c = Triangular666(5);

julia> code = Stabilizer(c)
+ XXXX_______________
+ _X_X_XX____________
+ __XXXX_XX__________
+ ____X__X__XX_______
+ _________X___X___XX
+ _____XX_XX__XX_____
+ _______XX__XX__XX__
+ __________XX__XX___
+ ____________XX__XX_
+ ZZZZ_______________
+ _Z_Z_ZZ____________
+ __ZZZZ_ZZ__________
+ ____Z__Z__ZZ_______
+ _________Z___Z___ZZ
+ _____ZZ_ZZ__ZZ_____
+ _______ZZ__ZZ__ZZ__
+ __________ZZ__ZZ___
+ ____________ZZ__ZZ_

julia> distance(c, DistanceMIPAlgorithm(solver=HiGHS))
5
```

More information can be seen in [landahl2011color](@cite)

### Fields
    $TYPEDFIELDS
"""
struct Triangular666 <: TriangularCode
    """The distance of the code."""
    d::Int
    function Triangular666(d)
        if d%2!=1
            throw(ArgumentError("Only odd distance triangular color codes are allowed.\nRefer to https://arxiv.org/abs/1108.5738"))
        elseif d<3
            throw(ArgumentError("Smallest allowed distance is 3.\nRefer to https://arxiv.org/abs/1108.5738"))
        end
        return new(d)
    end
end

Triangular488() = Triangular488(3) # smallest d
Triangular666() = Triangular666(3) # smallest d

parity_matrix_x(c::TriangularCode) = _colorcode_get_check_matrix(c)
parity_matrix_z(c::TriangularCode) = _colorcode_get_check_matrix(c)

function _colorcode_get_check_matrix(c::Triangular666)
    n = code_n(c)
    num_checks = (n-1)÷2
    num_layers = (c.d-1)÷2
    checks = zeros(Bool, num_checks, n)

    i = 1
    checks_written = 0
    for layer in 1:num_layers
        # extend half 6-gons from last iteration to full hexagons
        num_6_gons = layer-1
        checks_written -= num_6_gons
        for j in 1:(num_6_gons)
            init_pos = i + 2*(j-1)
            checks[checks_written+1,init_pos+2*(layer-1)+1] = 1
            checks[checks_written+1,init_pos+2*(layer-1)+2] = 1
            checks_written+=1
        end

        # red trapezoid
        checks[checks_written+1,i] = 1
        checks[checks_written+1,i+(layer-1)*2+1] = 1
        checks[checks_written+1,i+2+4*(layer-1)] = 1
        checks[checks_written+1,i+2+4*(layer-1)+1] = 1
        checks_written += 1

        # blue trapezoid
        checks[checks_written+1,i+1+4*(layer-1)] = 1
        checks[checks_written+1,i+1+4*(layer-1)+layer*2] = 1
        checks[checks_written+1,i+5+8*(layer-1)] = 1
        checks[checks_written+1,i+5+8*(layer-1)+1] = 1
        checks_written += 1

        # red hexagons
        for j in 1:(layer-1)
            checks[checks_written+1,i+(j-1)*2+1] = 1
            checks[checks_written+1,i+(j-1)*2+2] = 1
            checks[checks_written+1,i+(j-1)*2+2+2*(layer-1)] = 1
            checks[checks_written+1,i+(j-1)*2+2+2*(layer-1)+1] = 1
            checks[checks_written+1,i+(j-1)*2+2+2*(layer-1)+layer*2] = 1
            checks[checks_written+1,i+(j-1)*2+2+2*(layer-1)+layer*2+1] = 1

            checks_written += 1
        end

        # blue hexagons
        for j in 1:(layer-1)
            init_pos = i+(j-1)*2+(layer-1)*2+1
            checks[checks_written+1, init_pos] = 1
            checks[checks_written+1, init_pos+1] = 1
            checks[checks_written+1, init_pos+2*layer] = 1
            checks[checks_written+1, init_pos+2*layer+1] = 1
            checks[checks_written+1, init_pos+4*layer] = 1
            checks[checks_written+1, init_pos+4*layer+1] = 1

            checks_written += 1
        end

        # green half 6gons
        for j in 0:(layer-1)
            init_pos = i+2*j+2+4*(layer-1)
            checks[checks_written+1,init_pos] = 1
            checks[checks_written+1,init_pos+1] = 1
            checks[checks_written+1,init_pos+2*layer] = 1
            checks[checks_written+1,init_pos+2*layer+1] = 1
            checks_written += 1
        end

        i += 4+6*(layer-1)
    end

    return checks
end

"""Returns the binary matrix defining the X stabilizers for the Triangular488 code. The Z stabilizers are the same.
Based on Fig. 2 of [landahl2011color](@cite)"""
function _colorcode_get_check_matrix(c::Triangular488)
    n = code_n(c)
    num_checks = (n-1)÷2
    num_layers = (c.d-1)÷2
    checks = zeros(Bool, num_checks, n)

    i = 1
    checks_written = 0
    for layer in 1:num_layers
        # Convert half 8-gons from previous layer into full 8-gons
        num_8_gons = layer-1
        checks_written -= num_8_gons
        for j in 1:(num_8_gons)
            checks[checks_written+1,i+2*layer+1+(j-1)*2] = 1
            checks[checks_written+1,i+2*layer+j*2] = 1

            offset = 0
            if layer == num_layers && num_layers%2==0
                offset = 1
            end

            checks[checks_written+1,(2*layer+1)+i+2*layer+1+(j-1)*2 - offset] = 1
            checks[checks_written+1,(2*layer+1)+i+2*layer+j*2 - offset] = 1

            checks_written += 1
        end

        # red 4-gons
        for j in 0:(layer-1)
            checks[checks_written+1,i+j*2] = 1
            checks[checks_written+1,i+1+j*2] = 1
            checks[checks_written+1,i+2*layer+j*2] = 1
            checks[checks_written+1,i+2*layer+1+j*2] = 1
            checks_written += 1
        end

        if layer%2 == 1
            # green half 8-gons on left side
            checks[checks_written+1,i] = 1
            checks[checks_written+1,i+2*layer] = 1
            checks[checks_written+1,i+4*layer] = 1
            checks[checks_written+1,i+4*layer+1] = 1
            checks_written += 1
        else
            # blue half 8-gon on right side
            checks[checks_written+1,i+1+(layer-1)*2] = 1
            checks[checks_written+1,i+2*layer+1+(layer-1)*2] = 1

            # when d=5,9,13,... the final row qubits is indexed slightly differently.
            offset = 0
            if layer == num_layers
                offset = 1
            end

            checks[checks_written+1,(i+4*layer)+layer*2-offset] = 1
            checks[checks_written+1,(i+4*layer)+1+layer*2-offset] = 1
            checks_written += 1
        end

        # blue/green half 8-gons on the bottom
        for j in 0:(layer-1)
            checks[checks_written+1,i+2*layer+j*2] = 1
            checks[checks_written+1,i+2*layer+1+j*2] = 1

            offset = 0
            if layer == num_layers && num_layers%2==0
                offset = 1
            end

            checks[checks_written+1,(2*layer+1)+i+2*layer+j*2 - offset] = 1
            checks[checks_written+1,(2*layer+1)+i+2*layer+1+j*2 - offset] = 1

            checks_written += 1
        end

        i += 4*layer
    end
    return checks
end

"""Returns which qubits each stabilizer touches when given a parity check matrix. Useful for debugging/testing."""
function _colorcode_get_qubit_indices(matrix::Matrix{Bool})
    for j in 1:size(matrix)[1] println(findall(>(0),matrix[j,:])) end
    return
end

# From https://arxiv.org/abs/1108.5738 Fig. 2's caption:
code_n(c::Triangular488) = (c.d^2+2c.d-1)÷2
code_n(c::Triangular666) = (3*c.d^2+1)÷4
code_k(c::TriangularCode) = 1

@testitem "Reed-Muller" begin
    using Test
    using Nemo: echelon_form, matrix, GF
    using QECCore.LinearAlgebra
    using QECCore
    using QECCore: generator

    function designed_distance(matrix, m, r)
        distance = 2 ^ (m - r)
        for row in eachrow(matrix)
            count = sum(row)
            if count < distance
                return false
            end
        end
        return true
    end

    # Generate binary matrix representing all possible binary strings of length `2ᵐ` encompassing the entire field `F(2ᵐ)`.
    function check_RM_m_m(m::Int)
        n = 2^m
        matrix = Matrix{Bool}(undef, n, n)
        for i in 0:(n-1)
            for j in 0:(n-1)
                matrix[i+1, j+1] = ((i & j) == j)
            end
        end
        return matrix
    end

    @testset "Test RM(r, m) properties" begin
        for m in 3:10
            for r in 3:m-1
                H = generator(ReedMuller(r, m))
                mat = matrix(GF(2), H)
                computed_rank = LinearAlgebra.rank(mat)
                expected_rank = sum(binomial.(m, 0:r))
                @test computed_rank == expected_rank
                @test designed_distance(H, m, r) == true
                @test rate(ReedMuller(r, m)) == sum(binomial.(m, 0:r)) / 2 ^ m == rate(RecursiveReedMuller(r, m))
                @test code_n(ReedMuller(r, m)) == 2 ^ m == code_n(RecursiveReedMuller(r, m))
                @test code_k(ReedMuller(r, m)) == sum(binomial.(m, 0:r)) == code_k(RecursiveReedMuller(r, m))
                @test distance(ReedMuller(r, m)) == 2 ^ (m - r) == distance(RecursiveReedMuller(r, m))
                H₁ = generator(RecursiveReedMuller(r, m))
                # generator(RecursiveReedMuller(r, m)) is canonically equivalent to the generator(ReedMuller(r, m)) under reduced row echelon form.
                @test echelon_form(matrix(GF(2), Matrix{Int64}(H))) == echelon_form(matrix(GF(2), Matrix{Int64}(H₁)))
                H = parity_matrix(ReedMuller(r, m))
                H₁ = parity_matrix(RecursiveReedMuller(r, m))
                # parity_matrix(RecursiveReedMuller(r, m)) is canonically equivalent to the parity_matrix(ReedMuller(r, m)) under reduced row echelon form.
                @test echelon_form(matrix(GF(2), Matrix{Int64}(H))) == echelon_form(matrix(GF(2), Matrix{Int64}(H₁)))
                # dim(ReedMuller(m - r - 1, m)) = dim(ReedMuller(r, m)^⊥).
                # ReedMuller(m - r - 1, m) = ReedMuller(r, m)^⊥ ∴ parity check matrix (H) of ReedMuller(r, m) is the generator matrix (G) for ReedMuller(m - r - 1, m).
                H₁ = parity_matrix(ReedMuller(m - r - 1, m))
                G₂ = generator(ReedMuller(r, m))
                @test size(H₁) == size(G₂)
                @test echelon_form(matrix(GF(2), Matrix{Int64}(H₁))) == echelon_form(matrix(GF(2), Matrix{Int64}(G₂)))
                G₃ = generator(ReedMuller(m - r - 1, m))
                H₄ = parity_matrix(ReedMuller(r, m))
                @test size(G₃) == size(H₄)
                # dim(RecursiveReedMuller(m - r - 1, m)) = dim(RecursiveReedMuller(r, m)^⊥).
                # RecursiveReedMuller(m - r - 1, m) = RecursiveReedMuller(r, m)^⊥ ∴ parity check matrix (H) of RecursiveReedMuller(r, m) is the generator matrix (G) for RecursiveReedMuller(m - r - 1, m).
                H₁ = parity_matrix(RecursiveReedMuller(m - r - 1, m))
                G₂ = generator(RecursiveReedMuller(r, m))
                @test echelon_form(matrix(GF(2), Matrix{Int64}(H₄))) == echelon_form(matrix(GF(2), Matrix{Int64}(G₃)))
                @test echelon_form(matrix(GF(2), Matrix{Int64}(H₁))) == echelon_form(matrix(GF(2), Matrix{Int64}(G₂)))
                G₃ = generator(RecursiveReedMuller(m - r - 1, m))
                H₄ = parity_matrix(RecursiveReedMuller(r, m))
                @test size(G₃) == size(H₄)
                @test echelon_form(matrix(GF(2), Matrix{Int64}(H₄))) == echelon_form(matrix(GF(2), Matrix{Int64}(G₃)))
            end
        end
    end

    @testset "Test special case 1: generator(RM(0, m))" begin
        for m in 3:10
            H = generator(ReedMuller(0, m))
            expected = ones(Int64, 1, 2^m)
            @test H == expected
        end
    end

    @testset "Test special case 2: generator(RM(m, m))" begin
        for m in 3:10
            H = generator(ReedMuller(m, m))
            expected = check_RM_m_m(m)
            @test echelon_form(matrix(GF(2), Matrix{Int64}(H))) == echelon_form(matrix(GF(2), expected))
        end
    end

    @testset "Test common examples of RM(r,m) codes" begin
        # Examples from [raaphorst2003reed](@cite), [djordjevic2021quantum](@cite), [abbe2020reed](@cite).
        # RM(0,3)
        @test generator(ReedMuller(0,3)) == [1 1 1 1 1 1 1 1]
        # RM(1,3)
        @test generator(ReedMuller(1,3)) == [1 1 1 1 1 1 1 1;
                                             1 1 1 1 0 0 0 0;
                                             1 1 0 0 1 1 0 0;
                                             1 0 1 0 1 0 1 0]
        # RM(2,3)
        @test generator(ReedMuller(2,3)) == [1 1 1 1 1 1 1 1;
                                             1 1 1 1 0 0 0 0;
                                             1 1 0 0 1 1 0 0;
                                             1 0 1 0 1 0 1 0;
                                             1 1 0 0 0 0 0 0;
                                             1 0 1 0 0 0 0 0;
                                             1 0 0 0 1 0 0 0]
        # RM(3,3)
        @test generator(ReedMuller(3,3)) == [1 1 1 1 1 1 1 1;
                                             1 1 1 1 0 0 0 0;
                                             1 1 0 0 1 1 0 0;
                                             1 0 1 0 1 0 1 0;
                                             1 1 0 0 0 0 0 0;
                                             1 0 1 0 0 0 0 0;
                                             1 0 0 0 1 0 0 0;
                                             1 0 0 0 0 0 0 0]
        # RM(2,4)
        @test generator(ReedMuller(2,4)) == [1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1;
                                             1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0;
                                             1 1 1 1 0 0 0 0 1 1 1 1 0 0 0 0;
                                             1 1 0 0 1 1 0 0 1 1 0 0 1 1 0 0;
                                             1 0 1 0 1 0 1 0 1 0 1 0 1 0 1 0;
                                             1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0;
                                             1 1 0 0 1 1 0 0 0 0 0 0 0 0 0 0;
                                             1 0 1 0 1 0 1 0 0 0 0 0 0 0 0 0;
                                             1 1 0 0 0 0 0 0 1 1 0 0 0 0 0 0;
                                             1 0 1 0 0 0 0 0 1 0 1 0 0 0 0 0;
                                             1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0]
    end
end

@testitem "Quantum Tillich-Zemor" begin

    using QuantumClifford
    using QuantumClifford: stab_looks_good
    using QuantumClifford.ECC
    using Nemo: matrix, GF
    using QECCore.LinearAlgebra
    using QECCore
    using QECCore: _create_circulant_matrix, _create_matrix_M_deterministic, random_TillichZemor_code
    using Random
    using Random: AbstractRNG

    function _theoretical_code_k(c::TillichZemor)
        C = _create_circulant_matrix(c.m)
        M = _create_matrix_M_deterministic(c.m, c.n, c.r)
        H = hcat(C, M)
        H_gf2 = matrix(GF(2), H)
        Ht_gf2 = transpose(H_gf2)
        k = c.n - rank(H_gf2)
        kT = c.m - rank(Ht_gf2) # c.m == size(H, 1)
        k_q = k^2 + kT^2
        return k_q
    end

    @testset "Testing Quantum Tillich-Zemor properties" begin
        for n in 4:2:20
            for m in 3:10
                for r in 3:5
                    if m ≥ r && (n - m)*r ≥ m
                        c = TillichZemor(n, m, r)
                        stab = parity_checks(c)
                        nₛ, kₛ = code_n(stab), code_k(stab)
                        H = stab_to_gf2(stab)
                        mat = matrix(GF(2), H)
                        computed_rank = rank(mat)
                        @test computed_rank == nₛ - kₛ
                        @test stab_looks_good(stab, remove_redundant_rows=true)
                        # test the derivation of [[N, K, _ ]] formules for these novel codes.
                        @test code_n(c) == nₛ && code_k(c) == kₛ == _theoretical_code_k(c)
                    end
                end
            end
        end
    end

    rng = MersenneTwister()
    @testset "Testing random Quantum Tillich-Zemor properties" begin
        for n in 4:2:20
            for m in 3:10
                for r in 3:5
                    if m ≥ r && (n - m)*r ≥ m
                        c = random_TillichZemor_code(rng, n, m, r)
                        stab = parity_checks(c)
                        nₛ, kₛ = code_n(stab), code_k(stab)
                        H = stab_to_gf2(stab)
                        mat = matrix(GF(2), H)
                        computed_rank = rank(mat)
                        @test computed_rank == nₛ - kₛ
                        @test stab_looks_good(stab, remove_redundant_rows=true)
                        @test code_n(c) == nₛ && code_k(c) == kₛ
                    end
                end
            end
        end
    end
end

@testitem "Codes" begin
    using QECCore
    using Test
    using TestItemRunner
    
    @testset "fivequbit" begin
        include("codes/fivequbit.jl")
    end

    @testset "repetition" begin
        include("codes/repetition.jl")
    end

    @testset "toric" begin
        include("codes/toric.jl")
    end

    @testset "surface" begin
        include("codes/surfacecode.jl")
    end

    @testset "steanecode" begin
        include("codes/steanecode.jl")
    end

    @testset "shorcode" begin
        include("codes/shorcode.jl")
    end

    @testset "clevecode" begin
        include("codes/clevecode.jl")
    end

    @testset "css" begin
        include("codes/css.jl")
    end

    @testset "quantumreedmuller" begin
        include("codes/quantumreedmuller.jl")
    end

    @testset "reedmuller" begin
        include("codes/reedmuller.jl")
    end

    @testset "color_codes" begin
        include("codes/color_codes.jl")
    end

    @testset "gottesman" begin
        include("codes/gottesman.jl")
    end

    @testset "golay" begin
        include("codes/golay.jl")
    end

    @testset "gallager" begin
        include("codes/gallager.jl")
    end
    
    @testset "goppa" begin
        include("codes/goppa.jl")
    end

    @testset "hamming" begin
        include("codes/hamming.jl")
    end

    @testset "Delfosse-Reichardt Repetition Code" begin
        include("codes/delfosse_reichardt_repcode.jl")
    end

    @testset "Delfosse-Reichardt Code" begin
        include("codes/delfosse_reichardt_code.jl")
    end

    @testset "Delfosse-Reichardt Generalized [[8,2,3]] Code" begin
        include("codes/delfosse_reichardt_823_code.jl")
    end

    @testset "Quantum Tanner Graph Codes" begin
        include("codes/quantumtannergraphproduct.jl")
    end

    @testset "Quantum Tillich-Zemor Codes" begin
        include("codes/tillichzemor.jl")
    end
    
    @testset "Circulant Bivariate Bicycle Codes" begin
        include("codes/generalized_circulant_bivariate_bicycle.jl")
    end
end

@testitem "[[4p, 2(p − 2), 4]] Delfosse-Reichardt RepCode" begin

    using JuMP
    using HiGHS
    using QuantumClifford
    using QuantumClifford: stab_looks_good
    using QuantumClifford.ECC
    using Nemo: matrix, GF
    using QECCore.LinearAlgebra
    using QECCore
    using QECCore: _extend_414_repetition_code

    @testset "Testing [[4p, 2(p − 2), 4]] Delfosse-Reichardt RepCode properties" begin
        # For p = 2, the code is trivial with k = 0 so we skip it in testing since the distance of a trivial code is infinite.
        for i in 2:5
            p = 2*i
            n = 4*p
            k = 2*(p - 2)
            c = DelfosseReichardtRep(p)
            stab = parity_checks(c)
            nₛ, kₛ = code_n(stab), code_k(stab)
            H = stab_to_gf2(stab)
            mat = matrix(GF(2), H)
            computed_rank = rank(mat)
            @test computed_rank == n - k && computed_rank == nₛ - kₛ && n == nₛ && k == kₛ
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
            @test stab_looks_good(stab, remove_redundant_rows=true)
        end

        # crosscheck parity check matrices from VIII. 1 Generalizing the [4, 1, 4]
        # classical repetition code, pg. 10 of https://arxiv.org/pdf/2008.05051
        blocks = 1
        @test _extend_414_repetition_code(blocks) == [1  1  1  1;
                                                      0  0  1  1;
                                                      0  1  0  1];
        blocks = 4
        # [16, 10, 4] classical linear code
        @test _extend_414_repetition_code(blocks) == [1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0;
                                                      0  0  0  0  1  1  1  1  0  0  0  0  0  0  0  0;
                                                      0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0;
                                                      0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1;
                                                      0  0  1  1  0  0  1  1  0  0  1  1  0  0  1  1;
                                                      0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1]
        blocks = 6
        # [24, 16, 4] classical linear code
        @test _extend_414_repetition_code(blocks) == [1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0;
                                                      0  0  0  0  1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0;
                                                      0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0;
                                                      0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0  0  0  0  0;
                                                      0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0;
                                                      0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1;
                                                      0  0  1  1  0  0  1  1  0  0  1  1  0  0  1  1  0  0  1  1  0  0  1  1;
                                                      0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1  0  1];
    end
end

# TODO Steane5 qubit code

"""
    $TYPEDEF

Steane code [steane1996error](@cite).
"""
struct Steane7 <: AbstractCSSCode end

_steane_mat() = Bool[0 0 0 1 1 1 1;
                    0 1 1 0 0 1 1;
                    1 0 1 0 1 0 1]

parity_matrix_x(c::Steane7) = _steane_mat()
parity_matrix_z(c::Steane7) = _steane_mat()

distance(c::Steane7) = 3

"""
    $TYPEDEF

A generalization of the circulant bivariate bicycle code introduced in [bravyi2024high](@cite),
extending the original three-term polynomial representation up to `l` terms (for `x`-powers) and
`m` terms (for `y`-powers).

## Bivariate Bicycle Codes

Bivariate bicycle codes are a class of group algebra codes defined for the finite
abelian group ``G = \\mathbb{Z}/\\ell\\mathbb{Z} \\times \\mathbb{Z}/m\\mathbb{Z}``. The
group algebra ``\\mathbb{F}_2[G]`` admits an identification with the quotient ring
``R = \\mathbb{F}_2[x,y]/(x^\\ell - 1, y^m - 1)``, where the standard basis consists of monomials
``{x^iy^j}`` for ``0 \\leq i < \\ell`` and ``0 \\leq j < m`` [eberhardt2024logical](@cite).
Within this framework, every pair of elements ``c,d \\in R`` determines a BB code ``(C(c,d)``
through the group algebra construction.

### Circulant Matrix Representation

BB codes admit a matrix representation via the [injective](https://en.wikipedia.org/wiki/Injective_function)
[ring homomorphism](https://en.wikipedia.org/wiki/Ring_homomorphism) [eberhardt2024logical](@cite):

```math
\\begin{aligned}
\\varphi: R = \\mathbb{F}_2[x,y]/(x^\\ell - 1, y^m - 1) \\rightarrow \\mathbb{F}_2^{\\ell m \\times \\ell m}
\\end{aligned}
```

where ``\\varphi(x) = S_\\ell \\otimes I_m`` and ``\\varphi(y) = I_\\ell \\otimes S_m`` provides
matrix representations of the algebraic generators. Through this mapping, any code-defining polynomials
``c,d \\in R`` correspond to parity-check matrices ``A = \\varphi(c)`` and ``B = \\varphi(d)`` composed
of tensor products of circulant blocks.

### Three-term Polynomials

The original construction in [bravyi2024high](@cite) constrained the polynomials to specific forms:

```math
\\begin{aligned}
a(x, y) = x^a + y^b + y^c, \\quad b(x, y) = y^d + x^e + x^f
\\end{aligned}
```

Thus, ``A`` and ``B`` can be expressed as ``A = A_1 + A_2 + A_3`` and ``B = B_1 + B_2 + B_3``. Consequently,
each stabilizer generator has weight at most 6 for any valid three-term polynomials [postema2025existencecharacterisationbivariatebicycle](@cite).

### Generalized Polynomials

We extend the original three-term construction of [bravyi2024high](@cite) to arbitrary finite sums
of commuting monomials in ``x`` and ``y``:

```math
\\begin{aligned}
A = \\sum_{i \\in I} x^{p_i} + \\sum_{j \\in J} y^{q_j}, \\quad B = \\sum_{k \\in K} x^{r_k} + \\sum_{l \\in L} y^{s_l}
\\end{aligned}
```

where index sets ``I, J, K, L`` are finite and non-empty, with powers bounded by:

```math
\\begin{aligned}
0 \\leq p_i, r_k \\leq \\ell-1, \\quad 0 \\leq q_j, s_l \\leq m-1
\\end{aligned}
```

## Commuting Shift Matrices

The matrices ``x = S_\\ell \\otimes I_m`` and ``y = I_\\ell \\otimes S_m`` form a
pair of commuting operators, where ``S_\\ell`` and ``S_m`` are cyclic shift matrices
of sizes ``\\ell \\times \\ell`` and ``m \\times m`` respectively, and ``I_\\ell``,
``I_m`` denote identity matrices of corresponding dimensions. Their commutativity
``xy = yx`` follows from the *mixed-product property* of Kronecker products [wang2024coprime](@cite):

```math
\\begin{aligned}
(A \\otimes B)(C \\otimes D) = (AC) \\otimes (BD)
\\end{aligned}
```

which yields:

```math
\\begin{aligned}
(S_\\ell \\otimes I_m)(I_\\ell \\otimes S_m) = (I_\\ell \\otimes S_m)(S_\\ell \\otimes I_m) = S_\\ell \\otimes S_m
\\end{aligned}
```

The set of monomials ``\\{x^i y^j \\mid 0 \\leq i < \\ell, 0 \\leq j < m}`` forms a basis for the matrix
algebra generated by ``x`` and ``y``, establishing a [bijection](https://en.wikipedia.org/wiki/Bijection)
between these monomials and the resulting ``(\\ell m) \\times (\\ell m)`` matrices. This correspondence
allows us to work equivalently with either the polynomial or matrix formulation [wang2024coprime](@cite).

## Parity Checks

The commuting polynomial matrices ``A = a(x, y)`` and ``B = b(x, y)`` define the code’s parity checks:

```math
\\begin{aligned}
H_x = [A \\mid B], \\quad H_z = [B^\\top \\mid A^\\top]
\\end{aligned}
```

The addition and multiplication on binary matrices are performed modulo 2. Both ``H_x``
and ``H_z`` are ``(n/2)×n`` matrices.

## Circulant Bivariate Bicycle Code

The BB code is represented by matrices `A` and `B`, defined as: ``A = A_1 + A_2 + A_3``
and ``B = B_1 + B_2 + B_3``.

!!! note
    Both A and B are matrices in which each row and column contains exactly three non-zero
    entries when using a 3-term polynomial representation [bravyi2024high](@cite).

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/qcga).

### Example

Here is `[[756, 16, ≤ 34]]` circulant bivariate bicycle code from Table 1 of [bravyi2024high](@cite)
with polynomials ``A = x^3 + y^10 + y^17`` and ``B = y^5 + x^3 + x^19``.

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> l, m = 21, 18;

julia> A = [(:x,3), (:y,10), (:y,17)];

julia> B = [(:y,5), (:x,3), (:x,19)];

julia> c = BivariateBicycleViaCirculantMat(l, m, A, B);

julia> code_n(c), code_k(c)
(756, 16)
```

## Generalized Circulant Bivariate Bicycle Code

Here is an example of `[[128, 14, 12]]` generalized circulant bivariate bicycle code
that uses 4-term polynomials ``c = x^2 + y + y^3 + y^4`` and ``d = y^2 + x + x^3 + x^4``
with group orders ``l, m = 8, 8`` from [eberhardt2024logical](@cite).

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> l, m = 8, 8;

julia> A = [(:x,2), (:y,1), (:y,3), (:y,4)];

julia> B = [(:y,2), (:x,1), (:x,3), (:x,4)];

julia> c = BivariateBicycleViaCirculantMat(l, m, A, B);

julia> code_n(c), code_k(c)
(128, 14)
```

Here is `[[18, 4, 4]]` generalized circulant bivariate bicycle code
that uses 3-term polynomials ``a = 1 + x + y`` and ``b = 1 + x^2 + y^2``
with group orders ``l, m = 3, 3`` from Table III of [wang2024coprime](@cite).

!!! note
    We can also employ 3-term polynomials of a different form than those proposed in [bravyi2024high](@cite).

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC;

julia> l, m = 3, 3;

julia> A = [(:x, 0), (:x, 1), (:y, 1)];

julia> B = [(:y, 0), (:x, 2), (:y, 2)];

julia> c = BivariateBicycleViaCirculantMat(l, m, A, B);

julia> code_n(c), code_k(c)
(18, 4)
```

!!! note
    The Bivariate Bicycle code ``\\mathrm{QC}(A,B)`` is a specific instance of the
    *Lifted Product* construction, where the underlying group is the direct product
    ``\\mathbb{Z}_\\ell \\times \\mathbb{Z}_m`` (with ``\\mathbb{Z}_j`` denoting the
    cyclic group of order ``j``).

Here is `[[36, 4, 6]]` generalized circulant bivariate bicycle code
that uses 3-term polynomials ``a = x + y^2 + y^3`` and ``b = 1 + y + x^2``
with group orders ``l, m = 3, 6`` from Table III of [wang2024coprime](@cite).

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC;

julia> import Hecke: group_algebra, GF, abelian_group, gens;

julia> l, m = 3, 6;

julia> GA = group_algebra(GF(2), abelian_group([l, m]));

julia> x, y = gens(GA);

julia> A = x + y^2 + y^3;

julia> B = 1 + y + x^2;

julia> c = two_block_group_algebra_code(A,B);

julia> code_n(c), code_k(c)
(36, 4)
```

### Fields
    $TYPEDFIELDS
"""
struct BivariateBicycleViaCirculantMat <: AbstractCSSCode
    """Dimension of cyclic shift matrix `Sₗ` where `x = Sₗ ⊗ Iₘ`"""
    l::Int
    """ Dimension of cyclic shift matrix `Sₘ` where `y = Iₗ ⊗ Sₘ`"""
    m::Int
    """Terms in matrix A, where each tuple is (:x or :y, power)"""
    A::Vector{Tuple{Symbol,Int}}
    """Terms in matrix B, where each tuple is (:x or :y, power)"""
    B::Vector{Tuple{Symbol,Int}}

    function BivariateBicycleViaCirculantMat(l, m, A, B)
        (l >= 0 && m >= 0) || throw(ArgumentError("l and m must be non-negative"))
        (length(A) >= 1 && length(B) >= 1) || throw(ArgumentError("A and B must each have at least one entry"))
        for (mat, terms) in [(:A, A), (:B, B)]
            for (var, pow) in terms
                var ∈ [:x, :y] || throw(ArgumentError("Matrix $mat contains invalid variable $var (must be :x or :y)"))
                pow >= 0 || throw(ArgumentError("Matrix $mat contains negative power $pow"))
                max_pow = var == :x ? l : m
                pow <= max_pow || throw(ArgumentError("Power $pow in matrix $mat exceeds maximum $max_pow for $var"))
            end
        end
        new(l, m, A, B)
    end
end

function parity_matrix_xz(c::BivariateBicycleViaCirculantMat)
    Iₗ = Matrix{Bool}(I, c.l, c.l)
    Iₘ = Matrix{Bool}(I, c.m, c.m)
    xₚ = Dict(i => kron(circshift(Iₗ, (0,i)), Iₘ) for i in 0:c.l)
    yₚ = Dict(i => kron(Iₗ, circshift(Iₘ, (0,i))) for i in 0:c.m)
    A = zeros(Bool, c.l*c.m, c.l*c.m)
    for (var, pow) in c.A
        mat = var == :x ? xₚ[pow] : yₚ[pow]
        A .+= mat
    end
    A = mod.(A, 2)
    B = zeros(Bool, c.l*c.m, c.l*c.m)
    for (var, pow) in c.B
        mat = var == :x ? xₚ[pow] : yₚ[pow]
        B .+= mat
    end
    B = mod.(B, 2)
    Hx = hcat(A, B)
    Hz = hcat(B', A')
    return Hx, Hz
end

code_n(c::BivariateBicycleViaCirculantMat) = 2*c.l*c.m

parity_matrix_x(c::BivariateBicycleViaCirculantMat) = parity_matrix_xz(c)[1]

parity_matrix_z(c::BivariateBicycleViaCirculantMat) = parity_matrix_xz(c)[2]

"""
    $TYPEDEF

A pedagogical example of a quantum error correcting [8,3] code used in [cleve1997efficient](@cite).
"""
struct Cleve8 <: AbstractQECC end

parity_matrix(c::Cleve8) = Bool[1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0;
                                0 0 0 0 0 0 0 0 1 1 1 1 1 1 1 1;
                                1 0 1 0 0 1 0 1 0 0 0 0 1 1 1 1;
                                1 0 1 0 1 0 1 0 0 0 1 1 0 0 1 1;
                                1 0 0 1 0 1 1 0 0 1 0 1 0 1 0 1]
                                

"""
    $TYPEDEF

The `[[8p, 4p − 2, 3]]` Delfosse-Reichardt Generalized `[[8,2,3]]` code is derived from the
quantum `[[8,2,3]]` code. These codes were introduced by Delfosse and Reichardt in the paper
*Short Shor-style syndrome sequences* [delfosse2020short](@cite). The parameter `p` specifies
the **number of blocks** in the code construction.

The `[[8, 2, 3]]` non-CSS code serves as the seed code for constructing Delfosse-Reichardt
generalized `[[8p, 4p − 2, 3]]`codes.

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> p = 1;

julia> c = parity_checks(DelfosseReichardt823(p))
+ ZZZZ____
+ XXXX____
+ ____ZZZZ
+ ____XXXX
+ _XYZ_XYZ
+ _ZXY_ZXY

julia> code_n(c), code_k(c)
(8, 2)
```

An `[[16, 6, 3]]` Delfosse-Reichardt Generalized `[[8,2,3]]` code from [delfosse2020short](@cite).

```jldoctest
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> p = 2;

julia> c = parity_checks(DelfosseReichardt823(p))
+ ZZZZ____________
+ XXXX____________
+ ____ZZZZ________
+ ____XXXX________
+ ________ZZZZ____
+ ________XXXX____
+ ____________ZZZZ
+ ____________XXXX
+ _XYZ_XYZ_XYZ_XYZ
+ _ZXY_ZXY_ZXY_ZXY

julia> code_n(c), code_k(c)
(16, 6)
```

### Fields
    $TYPEDFIELDS


See also: [`DelfosseReichardt`](@ref), [`DelfosseReichardtRep`](@ref)
"""
struct DelfosseReichardt823 <: AbstractQECC
    """The number of blocks in the Delfosse-Reichardt generalized [[8, 2, 3]] code."""
    p::Int
    function DelfosseReichardt823(p)
        p < 1 && throw(ArgumentError("The number of blocks must be at least 1 to construct a valid code."))
        new(p)
    end
end

# The `[[8, 2, 3]]` non-CSS code serves as the seed code for constructing Delfosse-Reichardt generalized `[[8p, 4p − 2, 3]]`codes.
_seed₈₂₃ = Bool[0  0  0  0  0  0  0  0  1  1  1  1  0  0  0  0;
                1  1  1  1  0  0  0  0  0  0  0  0  0  0  0  0;
                0  0  0  0  0  0  0  0  0  0  0  0  1  1  1  1;
                0  0  0  0  1  1  1  1  0  0  0  0  0  0  0  0;
                0  1  1  0  0  1  1  0  0  0  1  1  0  0  1  1;
                0  0  1  1  0  0  1  1  0  1  0  1  0  1  0  1]

function parity_matrix(c::DelfosseReichardt823)
    H = _seed₈₂₃
    n = size(H,2)÷2
    Hx = H[:, 1:n]
    Hz = H[:, n+1:2n]
    tab_x = zeros(Bool, size(Hx,1)-2, size(Hx,2))
    tab_z = zeros(Bool, size(Hz,1)-2, size(Hz,2))
    Hx_rep₁ = Hx[1:4, :]
    Hz_rep₁ = Hz[1:4, :]
    Hx_rep₂ = Hx[5:6, :]
    Hz_rep₂ = Hz[5:6, :]
    rows_x = [hcat(fill(tab_x, i-1)..., Hx_rep₁, fill(tab_x, c.p-i)...) for i in 1:c.p]
    rows_z = [hcat(fill(tab_z, i-1)..., Hz_rep₁, fill(tab_z, c.p-i)...) for i in 1:c.p]
    Dx = vcat(rows_x...)
    Dz = vcat(rows_z...)
    D = [Dx Dz]
    Ex = hcat(fill(Hx_rep₂, c.p)...)
    Ez = hcat(fill(Hz_rep₂, c.p)...)
    E = [Ex Ez]
    extended_H = vcat(D, E)
    return extended_H
end

code_n(c::DelfosseReichardt823) = 8*c.p

code_k(c::DelfosseReichardt823) = 4*c.p - 2

distance(c::DelfosseReichardt823) = 3

module QECCore

using SparseArrays
using LinearAlgebra
using Combinatorics
using Graphs
using Random: GLOBAL_RNG, AbstractRNG, randperm, rand, MersenneTwister, randperm

using DocStringExtensions

# interfaces
export distance, parity_matrix, code_n, code_s, code_k, parity_matrix_x, parity_matrix_z,
rate, metacheck_matrix_x, metacheck_matrix_z, metacheck_matrix, bivariate_bicycle_code_k,
generator_polynomial
export AbstractECC, AbstractQECC, AbstractCECC, AbstractCSSCode, AbstractDistanceAlg

# QEC Codes
export Perfect5, Cleve8, Gottesman

# CSS Codes
export Toric, Bitflip3, Phaseflip3, Shor9, Steane7, Surface, CSS, QuantumReedMuller, Triangular488, Triangular666,
DelfosseReichardt, DelfosseReichardtRep, DelfosseReichardt823, QuantumTannerGraphProduct, CyclicQuantumTannerGraphProduct,
TillichZemor, random_TillichZemor_code, BivariateBicycleViaCirculantMat

# Classical Codes
export RepCode, ReedMuller, RecursiveReedMuller, Golay, Hamming, random_Gallager_ldpc, Goppa, random_Goppa_code

# utilities
export search_self_orthogonal_rm_code, hgp

include("interface.jl")
include("codes/util.jl")

# Classical Codes
include("codes/classical/hamming.jl")
include("codes/classical/repetition.jl")
include("codes/classical/golay.jl")
include("codes/classical/gallager.jl")
include("codes/classical/goppa.jl")

# Quantum Codes
include("codes/quantum/css.jl")
include("codes/quantum/fivequbit.jl")
include("codes/quantum/toric.jl")
include("codes/quantum/clevecode.jl")
include("codes/quantum/shorcode.jl")
include("codes/quantum/steanecode.jl")
include("codes/quantum/surface.jl")
include("codes/quantum/bitflipcode.jl")
include("codes/quantum/gottesman.jl")
include("codes/quantum/color_codes.jl")
include("codes/quantum/quantumtannergraphproduct.jl")
include("codes/quantum/tillichzemor.jl")
include("codes/quantum/generalized_circulant_bivariate_bicycle.jl")

# Reed-Muller Codes
include("codes/classical/reedmuller.jl")
include("codes/classical/recursivereedmuller.jl")
include("codes/quantum/quantumreedmuller.jl")

# Delfosse-Reichardt Codes
include("codes/quantum/delfosse_reichardt_code.jl")
include("codes/quantum/delfosse_reichardt_repcode.jl")
include("codes/quantum/delfosse_reichardt_823_code.jl")

function __init__()
    ENV["NEMO_PRINT_BANNER"] = "false"
    ENV["HECKE_PRINT_BANNER"] = "false"
    ENV["OSCAR_PRINT_BANNER"] = "false"

    if isdefined(Base.Experimental, :register_error_hint)
        Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
            if exc.f == parity_matrix_x || exc.f == parity_matrix_z
                print(io, "\n Hint: This error usually occurs when trying to call `parity_matrix_x` or `parity_matrix_z` on a non-CSS quantum code.")
            end
        end
    end
end

end

@testitem "Surface" begin
    using Test
    using QECCore

    @testset "Surface" begin
        c = Surface(2,2)
        @test parity_matrix(c) == Bool[1 0 1 0 1 0 0 0 0 0;
                                    0 1 0 1 1 0 0 0 0 0;
                                    0 0 0 0 0 1 1 0 0 1;
                                    0 0 0 0 0 0 0 1 1 1]
        @test parity_matrix_x(c) == Bool[1 0 1 0 1;
                                        0 1 0 1 1]
        @test parity_matrix_z(c) == Bool[1 1 0 0 1;
                                        0 0 1 1 1]
        @test distance(c) == 2
        @test code_n(c) == 5
        @test code_s(c) == 4
    end
end

"""
    $TYPEDEF

`Perfect5` code [lafiamme1996perfect](@cite) is the smallest qubit stabilizer code to correct a single-qubit error.
"""
struct Perfect5 <: AbstractQECC end

parity_matrix(c::Perfect5) = Bool[1 0 0 1 0 0 1 1 0 0;
                                0 1 0 0 1 0 0 1 1 0;
                                1 0 1 0 0 0 0 0 1 1;
                                0 1 0 1 0 1 0 0 0 1]
distance(c::Perfect5) = 3

"""
    $TYPEDEF

Shor9 code [shor1995scheme](@cite)is a nine-qubit CSS code that is the first quantum error-correcting code.
"""
struct Shor9 <: AbstractCSSCode end

parity_matrix_x(c::Shor9) = Bool[1 1 1 1 1 1 0 0 0 ;
                                0 0 0 1 1 1 1 1 1 ]

parity_matrix_z(c::Shor9) = Bool[1 1 0 0 0 0 0 0 0;
                                0 1 1 0 0 0 0 0 0;
                                0 0 0 1 1 0 0 0 0;
                                0 0 0 0 1 1 0 0 0;
                                0 0 0 0 0 0 1 1 0;
                                0 0 0 0 0 0 0 1 1]

distance(c::Shor9) = 3

"""
    $TYPEDEF

The family of `[[2ᵐ - 1, 1, 3]]` CSS Quantum-Reed-Muller codes, as discovered by Steane in his 1999 paper [steane1999quantum](@cite).

Quantum codes are constructed from shortened Reed-Muller codes `RM(1, m)`, by removing the first row and column of the generator matrix `Gₘ`. Similarly, we can define truncated dual codes `RM(m - 2, m)` using the generator matrix `Hₘ` [anderson2014fault](@cite). The quantum Reed-Muller codes `QRM(m)` derived from `RM(1, m)` are CSS codes. 

Given that the stabilizers of the quantum code are defined through the generator matrix of the classical code, the minimum distance of the quantum code corresponds to the minimum distance of the dual classical code, which is `d = 3`, thus it can correct any single qubit error. Since one stabilizer from the original and one from the dual code are removed in the truncation process, the code parameters are `[[2ᵐ - 1, 1, 3]]`.

You might be interested in consulting [anderson2014fault](@cite) and [campbell2012magic](@cite) as well.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/quantum_reed_muller).

See also: [`ReedMuller`](@ref) and [`RecursiveReedMuller`](@ref)

### Fields
    $TYPEDFIELDS
"""
struct QuantumReedMuller <: AbstractCSSCode
    """The log-length of the code."""
    m::Int
    function QuantumReedMuller(m)
        if  m < 3
            throw(DomainError("Invalid parameters: m must be bigger than 2 in order to have a valid code."))
        end
        new(m)
    end
end

code_n(c::QuantumReedMuller) = 2^c.m - 1

code_k(c::QuantumReedMuller) = 1

distance(c::QuantumReedMuller) = 3

parity_matrix_x(c::QuantumReedMuller) = generator(RecursiveReedMuller(1, c.m))[2:end, 2:end]

parity_matrix_z(c::QuantumReedMuller) = generator(RecursiveReedMuller(c.m-2, c.m))[2:end, 2:end]

"""
    $TYPEDEF

The family of classical binary Golay codes were discovered by Edouard Golay
in his 1949 paper [golay1949notes](@cite), where he described the binary
`[23, 12, 7]` Golay code.

There are two binary Golay codes:

- Binary `[23, 12, 7]` Golay code: The perfect code with code length `n = 23`
and dimension `k = 12`. By puncturing in any of the coordinates of parity check
matrix `H` = `[24, 12, 8]`, we obtain a `[23, 12, 7]` Golay code.

- Extended Binary `[24, 12, 8]` Golay code: Obtained by adding a parity check bit
to `[23, 12, 7]`. The bordered reverse circulant matrix `(A)` of `[24, 12, 8]`
Golay code is self-dual, i.e., `A₂₄` is same as A₂₄'.

The parity check matrix is defined as follows: `H₂₄ = [I₁₂ | A']` where `I₁₂` is the
`12 × 12` identity matrix and `A` is a bordered reverse circulant matrix. Puncturing
and then extending any column in​ with an overall parity check `H₂₃` reconstructs
the original parity check matrix `H₂₄`. Thus, all punctured codes are equivalent.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/golay).

### Fields
    $TYPEDFIELDS
"""
struct Golay <: AbstractCECC
    """The number of bits in the code."""
    n::Int

    function Golay(n)
        if !(n in (23, 24))
            throw(ArgumentError("Invalid parameters: `n` must be either 24 or 23 to obtain a valid code."))
        end
        new(n)
    end
end

# bordered reverse circulant matrix (see section 1.9.1, pg. 30-33) of [huffman2010fundamentals](@cite).
function _create_A₂₄_golay(n::Int)
    A = zeros(Int, n ÷ 2, n ÷ 2)
    # Define the squared values modulo 11.
    squares_mod₁₁ = [0, 1, 4, 9, 5, 3, 3, 5, 9, 4, 1]
    A[1, 2:end] .= 1
    A[2, 1] = 1
    for i in squares_mod₁₁
        A[2, i + 2] = 1
    end
    # Fill in the rest of the rows using the reverse circulant property.
    for i in 3:n ÷ 2
        A[i, 2:end] = circshift(A[i - 1, 2:end], -1)
        A[i, 1] = 1
    end
    return A
end

function generator(g::Golay)
    if g.n == 24
        A₂₄ = _create_A₂₄_golay(24)
        I₁₂ = LinearAlgebra.Diagonal(ones(Int, g.n ÷ 2))
        G₂₄ = hcat(I₁₂, (A₂₄)')
        return G₂₄
    else
        A₂₄ = _create_A₂₄_golay(24)
        A₂₃ = A₂₄[:, 1:end - 1]
        I₁₂ = LinearAlgebra.Diagonal(ones(Int, g.n ÷ 2))
        G₂₃ = hcat(I₁₂, (A₂₃)')
        return G₂₃
    end
end

function parity_matrix(g::Golay)
    if g.n == 24
        A₂₄ = _create_A₂₄_golay(24)
        I₁₂ = LinearAlgebra.Diagonal(ones(Int, g.n ÷ 2))
        H₂₄ = hcat((A₂₄)', I₁₂)
        return H₂₄
    else
        A₂₄ = _create_A₂₄_golay(24)
        A₂₃ = A₂₄[:, 1:end - 1]
        I₁₂ = LinearAlgebra.Diagonal(ones(Int, g.n ÷ 2))
        H₂₃ = hcat((A₂₃)', I₁₂)
        return H₂₃
    end
end

code_n(g::Golay) = g.n

code_k(g::Golay) = 12

distance(g::Golay) = code_n(g::Golay) - code_k(g::Golay) - 4
